// ============================================================================
//
// Copyright (c) 2006-2015, Talend Inc.
//
// This source code has been automatically generated by_Talend Open Studio for Data Integration
// / Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


package com_casus_where2test_migration.importcasessachsen_0_1;

import routines.Logging;
import routines.Numeric;
import routines.DataOperation;
import routines.TalendDataGenerator;
import routines.TalendStringUtil;
import routines.TalendString;
import routines.StringHandling;
import routines.Relational;
import routines.TalendDate;
import routines.Mathematical;
import routines.system.*;
import routines.system.api.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.math.BigDecimal;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Comparator;
 




	//the import part of tJava_2
	//import java.util.List;

	//the import part of tJava_1
	//import java.util.List;

	//the import part of tJavaRow_1
	//import java.util.List;


@SuppressWarnings("unused")

/**
 * Job: ImportCasesSachsen Purpose: <br>
 * Description:  <br>
 * @author 
 * @version 7.3.1.20200219_1130
 * @status 
 */
public class ImportCasesSachsen implements TalendJob {

protected static void logIgnoredError(String message, Throwable cause) {
       System.err.println(message);
       if (cause != null) {
               cause.printStackTrace();
       }

}


	public final Object obj = new Object();

	// for transmiting parameters purpose
	private Object valueObject = null;

	public Object getValueObject() {
		return this.valueObject;
	}

	public void setValueObject(Object valueObject) {
		this.valueObject = valueObject;
	}
	
	private final static String defaultCharset = java.nio.charset.Charset.defaultCharset().name();

	
	private final static String utf8Charset = "UTF-8";
	//contains type for every context property
	public class PropertiesWithType extends java.util.Properties {
		private static final long serialVersionUID = 1L;
		private java.util.Map<String,String> propertyTypes = new java.util.HashMap<>();
		
		public PropertiesWithType(java.util.Properties properties){
			super(properties);
		}
		public PropertiesWithType(){
			super();
		}
		
		public void setContextType(String key, String type) {
			propertyTypes.put(key,type);
		}
	
		public String getContextType(String key) {
			return propertyTypes.get(key);
		}
	}
	
	// create and load default properties
	private java.util.Properties defaultProps = new java.util.Properties();
	// create application properties with default
	public class ContextProperties extends PropertiesWithType {

		private static final long serialVersionUID = 1L;

		public ContextProperties(java.util.Properties properties){
			super(properties);
		}
		public ContextProperties(){
			super();
		}

		public void synchronizeContext(){
			
			if(application != null){
				
					this.setProperty("application", application.toString());
				
			}
			
			if(cleanDBOn != null){
				
					this.setProperty("cleanDBOn", cleanDBOn.toString());
				
			}
			
			if(parentMap != null){
				
					this.setProperty("parentMap", parentMap.toString());
				
			}
			
			if(rootPath != null){
				
					this.setProperty("rootPath", rootPath.toString());
				
			}
			
			if(syncDBOn != null){
				
					this.setProperty("syncDBOn", syncDBOn.toString());
				
			}
			
			if(default_user != null){
				
					this.setProperty("default_user", default_user.toString());
				
			}
			
			if(errorLogFile != null){
				
					this.setProperty("errorLogFile", errorLogFile.toString());
				
			}
			
			if(inputDir != null){
				
					this.setProperty("inputDir", inputDir.toString());
				
			}
			
			if(inputPath != null){
				
					this.setProperty("inputPath", inputPath.toString());
				
			}
			
			if(logDir != null){
				
					this.setProperty("logDir", logDir.toString());
				
			}
			
			if(logPath != null){
				
					this.setProperty("logPath", logPath.toString());
				
			}
			
			if(migrationLogFile != null){
				
					this.setProperty("migrationLogFile", migrationLogFile.toString());
				
			}
			
			if(outputDir != null){
				
					this.setProperty("outputDir", outputDir.toString());
				
			}
			
			if(outputPath != null){
				
					this.setProperty("outputPath", outputPath.toString());
				
			}
			
			if(rowLogFile != null){
				
					this.setProperty("rowLogFile", rowLogFile.toString());
				
			}
			
			if(tempDir != null){
				
					this.setProperty("tempDir", tempDir.toString());
				
			}
			
			if(tempPath != null){
				
					this.setProperty("tempPath", tempPath.toString());
				
			}
			
			if(writeToDB != null){
				
					this.setProperty("writeToDB", writeToDB.toString());
				
			}
			
			if(w2tpostgre_AdditionalParams != null){
				
					this.setProperty("w2tpostgre_AdditionalParams", w2tpostgre_AdditionalParams.toString());
				
			}
			
			if(w2tpostgre_Database != null){
				
					this.setProperty("w2tpostgre_Database", w2tpostgre_Database.toString());
				
			}
			
			if(w2tpostgre_Login != null){
				
					this.setProperty("w2tpostgre_Login", w2tpostgre_Login.toString());
				
			}
			
			if(w2tpostgre_Password != null){
				
					this.setProperty("w2tpostgre_Password", w2tpostgre_Password.toString());
				
			}
			
			if(w2tpostgre_Port != null){
				
					this.setProperty("w2tpostgre_Port", w2tpostgre_Port.toString());
				
			}
			
			if(w2tpostgre_Schema != null){
				
					this.setProperty("w2tpostgre_Schema", w2tpostgre_Schema.toString());
				
			}
			
			if(w2tpostgre_Server != null){
				
					this.setProperty("w2tpostgre_Server", w2tpostgre_Server.toString());
				
			}
			
		}

public String application;
public String getApplication(){
	return this.application;
}
public Boolean cleanDBOn;
public Boolean getCleanDBOn(){
	return this.cleanDBOn;
}
public Object parentMap;
public Object getParentMap(){
	return this.parentMap;
}
public String rootPath;
public String getRootPath(){
	return this.rootPath;
}
public Boolean syncDBOn;
public Boolean getSyncDBOn(){
	return this.syncDBOn;
}
public String default_user;
public String getDefault_user(){
	return this.default_user;
}
public String errorLogFile;
public String getErrorLogFile(){
	return this.errorLogFile;
}
public String inputDir;
public String getInputDir(){
	return this.inputDir;
}
public String inputPath;
public String getInputPath(){
	return this.inputPath;
}
public String logDir;
public String getLogDir(){
	return this.logDir;
}
public String logPath;
public String getLogPath(){
	return this.logPath;
}
public String migrationLogFile;
public String getMigrationLogFile(){
	return this.migrationLogFile;
}
public String outputDir;
public String getOutputDir(){
	return this.outputDir;
}
public String outputPath;
public String getOutputPath(){
	return this.outputPath;
}
public String rowLogFile;
public String getRowLogFile(){
	return this.rowLogFile;
}
public String tempDir;
public String getTempDir(){
	return this.tempDir;
}
public String tempPath;
public String getTempPath(){
	return this.tempPath;
}
public Boolean writeToDB;
public Boolean getWriteToDB(){
	return this.writeToDB;
}
public String w2tpostgre_AdditionalParams;
public String getW2tpostgre_AdditionalParams(){
	return this.w2tpostgre_AdditionalParams;
}
public String w2tpostgre_Database;
public String getW2tpostgre_Database(){
	return this.w2tpostgre_Database;
}
public String w2tpostgre_Login;
public String getW2tpostgre_Login(){
	return this.w2tpostgre_Login;
}
public java.lang.String w2tpostgre_Password;
public java.lang.String getW2tpostgre_Password(){
	return this.w2tpostgre_Password;
}
public String w2tpostgre_Port;
public String getW2tpostgre_Port(){
	return this.w2tpostgre_Port;
}
public String w2tpostgre_Schema;
public String getW2tpostgre_Schema(){
	return this.w2tpostgre_Schema;
}
public String w2tpostgre_Server;
public String getW2tpostgre_Server(){
	return this.w2tpostgre_Server;
}
	}
	protected ContextProperties context = new ContextProperties(); // will be instanciated by MS.
	public ContextProperties getContext() {
		return this.context;
	}
	private final String jobVersion = "0.1";
	private final String jobName = "ImportCasesSachsen";
	private final String projectName = "COM_CASUS_WHERE2TEST_MIGRATION";
	public Integer errorCode = null;
	private String currentComponent = "";
	
		private final java.util.Map<String, Object> globalMap = new java.util.HashMap<String, Object>();
        private final static java.util.Map<String, Object> junitGlobalMap = new java.util.HashMap<String, Object>();
	
		private final java.util.Map<String, Long> start_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Long> end_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Boolean> ok_Hash = new java.util.HashMap<String, Boolean>();
		public  final java.util.List<String[]> globalBuffer = new java.util.ArrayList<String[]>();
	

private RunStat runStat = new RunStat();

	// OSGi DataSource
	private final static String KEY_DB_DATASOURCES = "KEY_DB_DATASOURCES";
	
	private final static String KEY_DB_DATASOURCES_RAW = "KEY_DB_DATASOURCES_RAW";

	public void setDataSources(java.util.Map<String, javax.sql.DataSource> dataSources) {
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		for (java.util.Map.Entry<String, javax.sql.DataSource> dataSourceEntry : dataSources.entrySet()) {
			talendDataSources.put(dataSourceEntry.getKey(), new routines.system.TalendDataSource(dataSourceEntry.getValue()));
		}
		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
		globalMap.put(KEY_DB_DATASOURCES_RAW, new java.util.HashMap<String, javax.sql.DataSource>(dataSources));
	}

	LogCatcherUtils tLogCatcher_1 = new LogCatcherUtils();

private final java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
private final java.io.PrintStream errorMessagePS = new java.io.PrintStream(new java.io.BufferedOutputStream(baos));

public String getExceptionStackTrace() {
	if ("failure".equals(this.getStatus())) {
		errorMessagePS.flush();
		return baos.toString();
	}
	return null;
}

private Exception exception;

public Exception getException() {
	if ("failure".equals(this.getStatus())) {
		return this.exception;
	}
	return null;
}

private class TalendException extends Exception {

	private static final long serialVersionUID = 1L;

	private java.util.Map<String, Object> globalMap = null;
	private Exception e = null;
	private String currentComponent = null;
	private String virtualComponentName = null;
	
	public void setVirtualComponentName (String virtualComponentName){
		this.virtualComponentName = virtualComponentName;
	}

	private TalendException(Exception e, String errorComponent, final java.util.Map<String, Object> globalMap) {
		this.currentComponent= errorComponent;
		this.globalMap = globalMap;
		this.e = e;
	}

	public Exception getException() {
		return this.e;
	}

	public String getCurrentComponent() {
		return this.currentComponent;
	}

	
    public String getExceptionCauseMessage(Exception e){
        Throwable cause = e;
        String message = null;
        int i = 10;
        while (null != cause && 0 < i--) {
            message = cause.getMessage();
            if (null == message) {
                cause = cause.getCause();
            } else {
                break;          
            }
        }
        if (null == message) {
            message = e.getClass().getName();
        }   
        return message;
    }

	@Override
	public void printStackTrace() {
		if (!(e instanceof TalendException || e instanceof TDieException)) {
			if(virtualComponentName!=null && currentComponent.indexOf(virtualComponentName+"_")==0){
				globalMap.put(virtualComponentName+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			}
			globalMap.put(currentComponent+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			System.err.println("Exception in component " + currentComponent + " (" + jobName + ")");
		}
		if (!(e instanceof TDieException)) {
			if(e instanceof TalendException){
				e.printStackTrace();
			} else {
				e.printStackTrace();
				e.printStackTrace(errorMessagePS);
				ImportCasesSachsen.this.exception = e;
			}
		}
		if (!(e instanceof TalendException)) {
		try {
			for (java.lang.reflect.Method m : this.getClass().getEnclosingClass().getMethods()) {
				if (m.getName().compareTo(currentComponent + "_error") == 0) {
					m.invoke(ImportCasesSachsen.this, new Object[] { e , currentComponent, globalMap});
					break;
				}
			}

			if(!(e instanceof TDieException)){
				tLogCatcher_1.addMessage("Java Exception", currentComponent, 6, e.getClass().getName() + ":" + e.getMessage(), 1);
				tLogCatcher_1Process(globalMap);
			}
			} catch (TalendException e) {
				// do nothing
			
		} catch (Exception e) {
			this.e.printStackTrace();
		}
		}
	}
}

			public void tPrejob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPrejob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tJava_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tJava_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPostjob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPostjob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tJava_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tJava_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tLogCatcher_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tLogCatcher_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tJavaRow_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tLogCatcher_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_11_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_11_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_10_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_10_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_9_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_9_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_14_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_14_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_5_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_6_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_6_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_7_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_7_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_8_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_8_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_15_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_15_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_16_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_16_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_17_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_17_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_18_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_18_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPrejob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tJava_2_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tPostjob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tJava_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tLogCatcher_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_11_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_10_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_9_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_14_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_5_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_6_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_7_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_8_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_15_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_16_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_17_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_18_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
	





public void tPrejob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPrejob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPrejob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPrejob_1", false);
		start_Hash.put("tPrejob_1", System.currentTimeMillis());
		
	
	currentComponent="tPrejob_1";

	
		int tos_count_tPrejob_1 = 0;
		

 



/**
 * [tPrejob_1 begin ] stop
 */
	
	/**
	 * [tPrejob_1 main ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 


	tos_count_tPrejob_1++;

/**
 * [tPrejob_1 main ] stop
 */
	
	/**
	 * [tPrejob_1 process_data_begin ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 



/**
 * [tPrejob_1 process_data_begin ] stop
 */
	
	/**
	 * [tPrejob_1 process_data_end ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 



/**
 * [tPrejob_1 process_data_end ] stop
 */
	
	/**
	 * [tPrejob_1 end ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 

ok_Hash.put("tPrejob_1", true);
end_Hash.put("tPrejob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk1", 0, "ok");
				}
				tJava_2Process(globalMap);



/**
 * [tPrejob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPrejob_1 finally ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 



/**
 * [tPrejob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPrejob_1_SUBPROCESS_STATE", 1);
	}
	

public void tJava_2Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tJava_2_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;





	
	/**
	 * [tJava_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tJava_2", false);
		start_Hash.put("tJava_2", System.currentTimeMillis());
		
	
	currentComponent="tJava_2";

	
		int tos_count_tJava_2 = 0;
		


Logging.log(
	this.getClass(), 
	Logging.Type.DEBUG, 
	Logging.SEPARATOR_DASHES
	);
		
Logging.log(
	this.getClass(), 
	Logging.Type.INFO, 
	"start"
	);

 



/**
 * [tJava_2 begin ] stop
 */
	
	/**
	 * [tJava_2 main ] start
	 */

	

	
	
	currentComponent="tJava_2";

	

 


	tos_count_tJava_2++;

/**
 * [tJava_2 main ] stop
 */
	
	/**
	 * [tJava_2 process_data_begin ] start
	 */

	

	
	
	currentComponent="tJava_2";

	

 



/**
 * [tJava_2 process_data_begin ] stop
 */
	
	/**
	 * [tJava_2 process_data_end ] start
	 */

	

	
	
	currentComponent="tJava_2";

	

 



/**
 * [tJava_2 process_data_end ] stop
 */
	
	/**
	 * [tJava_2 end ] start
	 */

	

	
	
	currentComponent="tJava_2";

	

 

ok_Hash.put("tJava_2", true);
end_Hash.put("tJava_2", System.currentTimeMillis());




/**
 * [tJava_2 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tJava_2 finally ] start
	 */

	

	
	
	currentComponent="tJava_2";

	

 



/**
 * [tJava_2 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tJava_2_SUBPROCESS_STATE", 1);
	}
	

public void tPostjob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPostjob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPostjob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPostjob_1", false);
		start_Hash.put("tPostjob_1", System.currentTimeMillis());
		
	
	currentComponent="tPostjob_1";

	
		int tos_count_tPostjob_1 = 0;
		

 



/**
 * [tPostjob_1 begin ] stop
 */
	
	/**
	 * [tPostjob_1 main ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 


	tos_count_tPostjob_1++;

/**
 * [tPostjob_1 main ] stop
 */
	
	/**
	 * [tPostjob_1 process_data_begin ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 



/**
 * [tPostjob_1 process_data_begin ] stop
 */
	
	/**
	 * [tPostjob_1 process_data_end ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 



/**
 * [tPostjob_1 process_data_end ] stop
 */
	
	/**
	 * [tPostjob_1 end ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 

ok_Hash.put("tPostjob_1", true);
end_Hash.put("tPostjob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk2", 0, "ok");
				}
				tJava_1Process(globalMap);



/**
 * [tPostjob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPostjob_1 finally ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 



/**
 * [tPostjob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPostjob_1_SUBPROCESS_STATE", 1);
	}
	

public void tJava_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tJava_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;





	
	/**
	 * [tJava_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tJava_1", false);
		start_Hash.put("tJava_1", System.currentTimeMillis());
		
	
	currentComponent="tJava_1";

	
		int tos_count_tJava_1 = 0;
		


Logging.log(this.getClass(), Logging.Type.INFO, "stop");
 



/**
 * [tJava_1 begin ] stop
 */
	
	/**
	 * [tJava_1 main ] start
	 */

	

	
	
	currentComponent="tJava_1";

	

 


	tos_count_tJava_1++;

/**
 * [tJava_1 main ] stop
 */
	
	/**
	 * [tJava_1 process_data_begin ] start
	 */

	

	
	
	currentComponent="tJava_1";

	

 



/**
 * [tJava_1 process_data_begin ] stop
 */
	
	/**
	 * [tJava_1 process_data_end ] start
	 */

	

	
	
	currentComponent="tJava_1";

	

 



/**
 * [tJava_1 process_data_end ] stop
 */
	
	/**
	 * [tJava_1 end ] start
	 */

	

	
	
	currentComponent="tJava_1";

	

 

ok_Hash.put("tJava_1", true);
end_Hash.put("tJava_1", System.currentTimeMillis());




/**
 * [tJava_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tJava_1 finally ] start
	 */

	

	
	
	currentComponent="tJava_1";

	

 



/**
 * [tJava_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tJava_1_SUBPROCESS_STATE", 1);
	}
	


public static class exceptionStruct implements routines.system.IPersistableRow<exceptionStruct> {
    final static byte[] commonByteArrayLock_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen = new byte[0];
    static byte[] commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen = new byte[0];

	
			    public java.util.Date moment;

				public java.util.Date getMoment () {
					return this.moment;
				}
				
			    public String pid;

				public String getPid () {
					return this.pid;
				}
				
			    public String root_pid;

				public String getRoot_pid () {
					return this.root_pid;
				}
				
			    public String father_pid;

				public String getFather_pid () {
					return this.father_pid;
				}
				
			    public String project;

				public String getProject () {
					return this.project;
				}
				
			    public String job;

				public String getJob () {
					return this.job;
				}
				
			    public String context;

				public String getContext () {
					return this.context;
				}
				
			    public Integer priority;

				public Integer getPriority () {
					return this.priority;
				}
				
			    public String type;

				public String getType () {
					return this.type;
				}
				
			    public String origin;

				public String getOrigin () {
					return this.origin;
				}
				
			    public String message;

				public String getMessage () {
					return this.message;
				}
				
			    public Integer code;

				public Integer getCode () {
					return this.code;
				}
				



	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen.length) {
				if(length < 1024 && commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen.length == 0) {
   					commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen = new byte[1024];
				} else {
   					commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen, 0, length);
			strReturn = new String(commonByteArray_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }
	private Integer readInteger(ObjectInputStream dis) throws IOException{
		Integer intReturn;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			intReturn = null;
		} else {
	    	intReturn = dis.readInt();
		}
		return intReturn;
	}

	private void writeInteger(Integer intNum, ObjectOutputStream dos) throws IOException{
		if(intNum == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeInt(intNum);
    	}
	}

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_COM_CASUS_WHERE2TEST_MIGRATION_ImportCasesSachsen) {

        	try {

        		int length = 0;
		
					this.moment = readDate(dis);
					
					this.pid = readString(dis);
					
					this.root_pid = readString(dis);
					
					this.father_pid = readString(dis);
					
					this.project = readString(dis);
					
					this.job = readString(dis);
					
					this.context = readString(dis);
					
						this.priority = readInteger(dis);
					
					this.type = readString(dis);
					
					this.origin = readString(dis);
					
					this.message = readString(dis);
					
						this.code = readInteger(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// java.util.Date
				
						writeDate(this.moment,dos);
					
					// String
				
						writeString(this.pid,dos);
					
					// String
				
						writeString(this.root_pid,dos);
					
					// String
				
						writeString(this.father_pid,dos);
					
					// String
				
						writeString(this.project,dos);
					
					// String
				
						writeString(this.job,dos);
					
					// String
				
						writeString(this.context,dos);
					
					// Integer
				
						writeInteger(this.priority,dos);
					
					// String
				
						writeString(this.type,dos);
					
					// String
				
						writeString(this.origin,dos);
					
					// String
				
						writeString(this.message,dos);
					
					// Integer
				
						writeInteger(this.code,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("moment="+String.valueOf(moment));
		sb.append(",pid="+pid);
		sb.append(",root_pid="+root_pid);
		sb.append(",father_pid="+father_pid);
		sb.append(",project="+project);
		sb.append(",job="+job);
		sb.append(",context="+context);
		sb.append(",priority="+String.valueOf(priority));
		sb.append(",type="+type);
		sb.append(",origin="+origin);
		sb.append(",message="+message);
		sb.append(",code="+String.valueOf(code));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(exceptionStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tLogCatcher_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tLogCatcher_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		exceptionStruct exception = new exceptionStruct();




	
	/**
	 * [tJavaRow_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tJavaRow_1", false);
		start_Hash.put("tJavaRow_1", System.currentTimeMillis());
		
	
	currentComponent="tJavaRow_1";

	
					if(execStat) {
						runStat.updateStatOnConnection(resourceMap,iterateId,0,0,"exception");
					}
				
		int tos_count_tJavaRow_1 = 0;
		

int nb_line_tJavaRow_1 = 0;

 



/**
 * [tJavaRow_1 begin ] stop
 */



	
	/**
	 * [tLogCatcher_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tLogCatcher_1", false);
		start_Hash.put("tLogCatcher_1", System.currentTimeMillis());
		
	
	currentComponent="tLogCatcher_1";

	
		int tos_count_tLogCatcher_1 = 0;
		

try {
	for (LogCatcherUtils.LogCatcherMessage lcm : tLogCatcher_1.getMessages()) {
		exception.type = lcm.getType();
		exception.origin = (lcm.getOrigin()==null || lcm.getOrigin().length()<1 ? null : lcm.getOrigin());
		exception.priority = lcm.getPriority();
		exception.message = lcm.getMessage();
		exception.code = lcm.getCode();
		
		exception.moment = java.util.Calendar.getInstance().getTime();
	
    	exception.pid = pid;
		exception.root_pid = rootPid;
		exception.father_pid = fatherPid;
	
    	exception.project = projectName;
    	exception.job = jobName;
    	exception.context = contextStr;
    		
 



/**
 * [tLogCatcher_1 begin ] stop
 */
	
	/**
	 * [tLogCatcher_1 main ] start
	 */

	

	
	
	currentComponent="tLogCatcher_1";

	

 


	tos_count_tLogCatcher_1++;

/**
 * [tLogCatcher_1 main ] stop
 */
	
	/**
	 * [tLogCatcher_1 process_data_begin ] start
	 */

	

	
	
	currentComponent="tLogCatcher_1";

	

 



/**
 * [tLogCatcher_1 process_data_begin ] stop
 */

	
	/**
	 * [tJavaRow_1 main ] start
	 */

	

	
	
	currentComponent="tJavaRow_1";

	
					if(execStat){
						runStat.updateStatOnConnection(iterateId,1,1,"exception");
					}
					

    Logging.log(this.getClass(), Logging.Type.ERROR,"exception: " + exception.message);
Logging.log(this.getClass(), Logging.Type.ERROR, ((String)globalMap.get("tLogCatcher_1_ERROR_MESSAGE")));


    nb_line_tJavaRow_1++;   

 


	tos_count_tJavaRow_1++;

/**
 * [tJavaRow_1 main ] stop
 */
	
	/**
	 * [tJavaRow_1 process_data_begin ] start
	 */

	

	
	
	currentComponent="tJavaRow_1";

	

 



/**
 * [tJavaRow_1 process_data_begin ] stop
 */
	
	/**
	 * [tJavaRow_1 process_data_end ] start
	 */

	

	
	
	currentComponent="tJavaRow_1";

	

 



/**
 * [tJavaRow_1 process_data_end ] stop
 */



	
	/**
	 * [tLogCatcher_1 process_data_end ] start
	 */

	

	
	
	currentComponent="tLogCatcher_1";

	

 



/**
 * [tLogCatcher_1 process_data_end ] stop
 */
	
	/**
	 * [tLogCatcher_1 end ] start
	 */

	

	
	
	currentComponent="tLogCatcher_1";

	
	}
} catch (Exception e_tLogCatcher_1) {
	logIgnoredError(String.format("tLogCatcher_1 - tLogCatcher failed to process log message(s) due to internal error: %s", e_tLogCatcher_1), e_tLogCatcher_1);
}

 

ok_Hash.put("tLogCatcher_1", true);
end_Hash.put("tLogCatcher_1", System.currentTimeMillis());




/**
 * [tLogCatcher_1 end ] stop
 */

	
	/**
	 * [tJavaRow_1 end ] start
	 */

	

	
	
	currentComponent="tJavaRow_1";

	

globalMap.put("tJavaRow_1_NB_LINE",nb_line_tJavaRow_1);
				if(execStat){
			  		runStat.updateStat(resourceMap,iterateId,2,0,"exception");
			  	}
			  	
 

ok_Hash.put("tJavaRow_1", true);
end_Hash.put("tJavaRow_1", System.currentTimeMillis());




/**
 * [tJavaRow_1 end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tLogCatcher_1 finally ] start
	 */

	

	
	
	currentComponent="tLogCatcher_1";

	

 



/**
 * [tLogCatcher_1 finally ] stop
 */

	
	/**
	 * [tJavaRow_1 finally ] start
	 */

	

	
	
	currentComponent="tJavaRow_1";

	

 



/**
 * [tJavaRow_1 finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tLogCatcher_1_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_11Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_11_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_11 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_11", false);
		start_Hash.put("tRunJob_11", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_11";

	
		int tos_count_tRunJob_11 = 0;
		


 



/**
 * [tRunJob_11 begin ] stop
 */
	
	/**
	 * [tRunJob_11 main ] start
	 */

	

	
	
	currentComponent="tRunJob_11";

	
	java.util.List<String> paraList_tRunJob_11 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_11.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_11.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_11.add("--father_node=tRunJob_11");
	      			
	        			paraList_tRunJob_11.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_11.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_11.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_11.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_11 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_11 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_11".equals(tRunJobName_tRunJob_11) && childResumePath_tRunJob_11 != null){
		paraList_tRunJob_11.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_11.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_11");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_11 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_11 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_11.put("application", context.application);
                    paraList_tRunJob_11.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_11.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_11.put("parentMap", context.parentMap);
                    paraList_tRunJob_11.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_11.put("rootPath", context.rootPath);
                    paraList_tRunJob_11.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_11.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_11.put("default_user", context.default_user);
                    paraList_tRunJob_11.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_11.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("inputDir", context.inputDir);
                    paraList_tRunJob_11.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("inputPath", context.inputPath);
                    paraList_tRunJob_11.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("logDir", context.logDir);
                    paraList_tRunJob_11.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("logPath", context.logPath);
                    paraList_tRunJob_11.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_11.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("outputDir", context.outputDir);
                    paraList_tRunJob_11.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("outputPath", context.outputPath);
                    paraList_tRunJob_11.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_11.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("tempDir", context.tempDir);
                    paraList_tRunJob_11.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("tempPath", context.tempPath);
                    paraList_tRunJob_11.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_11.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_11.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_11.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_11.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_11().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_11 = context.propertyNames();
		while (propertyNames_tRunJob_11.hasMoreElements()) {
			String key_tRunJob_11 = (String) propertyNames_tRunJob_11.nextElement();
			Object value_tRunJob_11 = (Object) context.get(key_tRunJob_11);
			if(value_tRunJob_11!=null) {  
				paraList_tRunJob_11.add("--context_param " + key_tRunJob_11 + "=" + value_tRunJob_11);
			} else {
				paraList_tRunJob_11.add("--context_param " + key_tRunJob_11 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_11 = null;

	
	
		com_casus_where2test_migration.casessachsengemeindedailypriorjul2020_0_1.CasesSachsenGemeindeDailyPriorJul2020 childJob_tRunJob_11 = new com_casus_where2test_migration.casessachsengemeindedailypriorjul2020_0_1.CasesSachsenGemeindeDailyPriorJul2020();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_11 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_11) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_11 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_11 : talendDataSources_tRunJob_11
			        .entrySet()) {
	            dataSources_tRunJob_11.put(talendDataSourceEntry_tRunJob_11.getKey(),
	                    talendDataSourceEntry_tRunJob_11.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_11.setDataSources(dataSources_tRunJob_11);
	    }
		  
			childJob_tRunJob_11.parentContextMap = parentContextMap_tRunJob_11;
		  
		
		String[][] childReturn_tRunJob_11 = childJob_tRunJob_11.runJob((String[]) paraList_tRunJob_11.toArray(new String[paraList_tRunJob_11.size()]));
		
            if(childJob_tRunJob_11.getErrorCode() == null){
                globalMap.put("tRunJob_11_CHILD_RETURN_CODE", childJob_tRunJob_11.getStatus() != null && ("failure").equals(childJob_tRunJob_11.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_11_CHILD_RETURN_CODE", childJob_tRunJob_11.getErrorCode());
            }
            if (childJob_tRunJob_11.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_11_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_11.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_11.getErrorCode();
                if (childJob_tRunJob_11.getErrorCode() != null || ("failure").equals(childJob_tRunJob_11.getStatus())) {
                    java.lang.Exception ce_tRunJob_11 = childJob_tRunJob_11.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_11!=null) ? (ce_tRunJob_11.getClass().getName() + ": " + ce_tRunJob_11.getMessage()) : ""));
                }

 


	tos_count_tRunJob_11++;

/**
 * [tRunJob_11 main ] stop
 */
	
	/**
	 * [tRunJob_11 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_11";

	

 



/**
 * [tRunJob_11 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_11 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_11";

	

 



/**
 * [tRunJob_11 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_11 end ] start
	 */

	

	
	
	currentComponent="tRunJob_11";

	

 

ok_Hash.put("tRunJob_11", true);
end_Hash.put("tRunJob_11", System.currentTimeMillis());




/**
 * [tRunJob_11 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_11:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk15", 0, "ok");
								} 
							
							tRunJob_10Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_11 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_11";

	

 



/**
 * [tRunJob_11 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_11_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_10Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_10_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_10 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_10", false);
		start_Hash.put("tRunJob_10", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_10";

	
		int tos_count_tRunJob_10 = 0;
		


 



/**
 * [tRunJob_10 begin ] stop
 */
	
	/**
	 * [tRunJob_10 main ] start
	 */

	

	
	
	currentComponent="tRunJob_10";

	
	java.util.List<String> paraList_tRunJob_10 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_10.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_10.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_10.add("--father_node=tRunJob_10");
	      			
	        			paraList_tRunJob_10.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_10.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_10.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_10.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_10 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_10 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_10".equals(tRunJobName_tRunJob_10) && childResumePath_tRunJob_10 != null){
		paraList_tRunJob_10.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_10.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_10");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_10 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_10 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_10.put("application", context.application);
                    paraList_tRunJob_10.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_10.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_10.put("parentMap", context.parentMap);
                    paraList_tRunJob_10.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_10.put("rootPath", context.rootPath);
                    paraList_tRunJob_10.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_10.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_10.put("default_user", context.default_user);
                    paraList_tRunJob_10.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_10.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("inputDir", context.inputDir);
                    paraList_tRunJob_10.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("inputPath", context.inputPath);
                    paraList_tRunJob_10.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("logDir", context.logDir);
                    paraList_tRunJob_10.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("logPath", context.logPath);
                    paraList_tRunJob_10.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_10.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("outputDir", context.outputDir);
                    paraList_tRunJob_10.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("outputPath", context.outputPath);
                    paraList_tRunJob_10.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_10.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("tempDir", context.tempDir);
                    paraList_tRunJob_10.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("tempPath", context.tempPath);
                    paraList_tRunJob_10.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_10.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_10.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_10.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_10.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_10().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_10 = context.propertyNames();
		while (propertyNames_tRunJob_10.hasMoreElements()) {
			String key_tRunJob_10 = (String) propertyNames_tRunJob_10.nextElement();
			Object value_tRunJob_10 = (Object) context.get(key_tRunJob_10);
			if(value_tRunJob_10!=null) {  
				paraList_tRunJob_10.add("--context_param " + key_tRunJob_10 + "=" + value_tRunJob_10);
			} else {
				paraList_tRunJob_10.add("--context_param " + key_tRunJob_10 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_10 = null;

	
	
		com_casus_where2test_migration.importcasessachsengemeindedaily_0_1.ImportCasesSachsenGemeindeDaily childJob_tRunJob_10 = new com_casus_where2test_migration.importcasessachsengemeindedaily_0_1.ImportCasesSachsenGemeindeDaily();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_10 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_10) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_10 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_10 : talendDataSources_tRunJob_10
			        .entrySet()) {
	            dataSources_tRunJob_10.put(talendDataSourceEntry_tRunJob_10.getKey(),
	                    talendDataSourceEntry_tRunJob_10.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_10.setDataSources(dataSources_tRunJob_10);
	    }
		  
			childJob_tRunJob_10.parentContextMap = parentContextMap_tRunJob_10;
		  
		
		String[][] childReturn_tRunJob_10 = childJob_tRunJob_10.runJob((String[]) paraList_tRunJob_10.toArray(new String[paraList_tRunJob_10.size()]));
		
            if(childJob_tRunJob_10.getErrorCode() == null){
                globalMap.put("tRunJob_10_CHILD_RETURN_CODE", childJob_tRunJob_10.getStatus() != null && ("failure").equals(childJob_tRunJob_10.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_10_CHILD_RETURN_CODE", childJob_tRunJob_10.getErrorCode());
            }
            if (childJob_tRunJob_10.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_10_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_10.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_10.getErrorCode();
                if (childJob_tRunJob_10.getErrorCode() != null || ("failure").equals(childJob_tRunJob_10.getStatus())) {
                    java.lang.Exception ce_tRunJob_10 = childJob_tRunJob_10.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_10!=null) ? (ce_tRunJob_10.getClass().getName() + ": " + ce_tRunJob_10.getMessage()) : ""));
                }

 


	tos_count_tRunJob_10++;

/**
 * [tRunJob_10 main ] stop
 */
	
	/**
	 * [tRunJob_10 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_10";

	

 



/**
 * [tRunJob_10 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_10 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_10";

	

 



/**
 * [tRunJob_10 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_10 end ] start
	 */

	

	
	
	currentComponent="tRunJob_10";

	

 

ok_Hash.put("tRunJob_10", true);
end_Hash.put("tRunJob_10", System.currentTimeMillis());




/**
 * [tRunJob_10 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_10:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk16", 0, "ok");
								} 
							
							tRunJob_9Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_10 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_10";

	

 



/**
 * [tRunJob_10 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_10_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_9Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_9_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_9 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_9", false);
		start_Hash.put("tRunJob_9", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_9";

	
		int tos_count_tRunJob_9 = 0;
		


 



/**
 * [tRunJob_9 begin ] stop
 */
	
	/**
	 * [tRunJob_9 main ] start
	 */

	

	
	
	currentComponent="tRunJob_9";

	
	java.util.List<String> paraList_tRunJob_9 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_9.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_9.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_9.add("--father_node=tRunJob_9");
	      			
	        			paraList_tRunJob_9.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_9.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_9.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_9.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_9 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_9 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_9".equals(tRunJobName_tRunJob_9) && childResumePath_tRunJob_9 != null){
		paraList_tRunJob_9.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_9.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_9");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_9 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_9 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_9.put("application", context.application);
                    paraList_tRunJob_9.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_9.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_9.put("parentMap", context.parentMap);
                    paraList_tRunJob_9.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_9.put("rootPath", context.rootPath);
                    paraList_tRunJob_9.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_9.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_9.put("default_user", context.default_user);
                    paraList_tRunJob_9.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_9.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("inputDir", context.inputDir);
                    paraList_tRunJob_9.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("inputPath", context.inputPath);
                    paraList_tRunJob_9.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("logDir", context.logDir);
                    paraList_tRunJob_9.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("logPath", context.logPath);
                    paraList_tRunJob_9.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_9.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("outputDir", context.outputDir);
                    paraList_tRunJob_9.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("outputPath", context.outputPath);
                    paraList_tRunJob_9.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_9.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("tempDir", context.tempDir);
                    paraList_tRunJob_9.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("tempPath", context.tempPath);
                    paraList_tRunJob_9.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_9.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_9.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_9.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_9.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_9().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_9 = context.propertyNames();
		while (propertyNames_tRunJob_9.hasMoreElements()) {
			String key_tRunJob_9 = (String) propertyNames_tRunJob_9.nextElement();
			Object value_tRunJob_9 = (Object) context.get(key_tRunJob_9);
			if(value_tRunJob_9!=null) {  
				paraList_tRunJob_9.add("--context_param " + key_tRunJob_9 + "=" + value_tRunJob_9);
			} else {
				paraList_tRunJob_9.add("--context_param " + key_tRunJob_9 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_9 = null;

	
	
		com_casus_where2test_migration.importcasessachsengemeindeweeklypriorjul2020_0_1.ImportCasesSachsenGemeindeWeeklyPriorJul2020 childJob_tRunJob_9 = new com_casus_where2test_migration.importcasessachsengemeindeweeklypriorjul2020_0_1.ImportCasesSachsenGemeindeWeeklyPriorJul2020();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_9 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_9) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_9 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_9 : talendDataSources_tRunJob_9
			        .entrySet()) {
	            dataSources_tRunJob_9.put(talendDataSourceEntry_tRunJob_9.getKey(),
	                    talendDataSourceEntry_tRunJob_9.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_9.setDataSources(dataSources_tRunJob_9);
	    }
		  
			childJob_tRunJob_9.parentContextMap = parentContextMap_tRunJob_9;
		  
		
		String[][] childReturn_tRunJob_9 = childJob_tRunJob_9.runJob((String[]) paraList_tRunJob_9.toArray(new String[paraList_tRunJob_9.size()]));
		
            if(childJob_tRunJob_9.getErrorCode() == null){
                globalMap.put("tRunJob_9_CHILD_RETURN_CODE", childJob_tRunJob_9.getStatus() != null && ("failure").equals(childJob_tRunJob_9.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_9_CHILD_RETURN_CODE", childJob_tRunJob_9.getErrorCode());
            }
            if (childJob_tRunJob_9.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_9_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_9.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_9.getErrorCode();
                if (childJob_tRunJob_9.getErrorCode() != null || ("failure").equals(childJob_tRunJob_9.getStatus())) {
                    java.lang.Exception ce_tRunJob_9 = childJob_tRunJob_9.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_9!=null) ? (ce_tRunJob_9.getClass().getName() + ": " + ce_tRunJob_9.getMessage()) : ""));
                }

 


	tos_count_tRunJob_9++;

/**
 * [tRunJob_9 main ] stop
 */
	
	/**
	 * [tRunJob_9 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_9";

	

 



/**
 * [tRunJob_9 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_9 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_9";

	

 



/**
 * [tRunJob_9 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_9 end ] start
	 */

	

	
	
	currentComponent="tRunJob_9";

	

 

ok_Hash.put("tRunJob_9", true);
end_Hash.put("tRunJob_9", System.currentTimeMillis());




/**
 * [tRunJob_9 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_9:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk12", 0, "ok");
								} 
							
							tRunJob_14Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_9 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_9";

	

 



/**
 * [tRunJob_9 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_9_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_14Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_14_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;





	
	/**
	 * [tRunJob_14 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_14", false);
		start_Hash.put("tRunJob_14", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_14";

	
		int tos_count_tRunJob_14 = 0;
		


 



/**
 * [tRunJob_14 begin ] stop
 */
	
	/**
	 * [tRunJob_14 main ] start
	 */

	

	
	
	currentComponent="tRunJob_14";

	
	java.util.List<String> paraList_tRunJob_14 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_14.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_14.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_14.add("--father_node=tRunJob_14");
	      			
	        			paraList_tRunJob_14.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_14.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_14.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_14.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_14 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_14 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_14".equals(tRunJobName_tRunJob_14) && childResumePath_tRunJob_14 != null){
		paraList_tRunJob_14.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_14.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_14");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_14 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_14 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_14.put("application", context.application);
                    paraList_tRunJob_14.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_14.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_14.put("parentMap", context.parentMap);
                    paraList_tRunJob_14.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_14.put("rootPath", context.rootPath);
                    paraList_tRunJob_14.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_14.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_14.put("default_user", context.default_user);
                    paraList_tRunJob_14.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_14.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("inputDir", context.inputDir);
                    paraList_tRunJob_14.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("inputPath", context.inputPath);
                    paraList_tRunJob_14.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("logDir", context.logDir);
                    paraList_tRunJob_14.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("logPath", context.logPath);
                    paraList_tRunJob_14.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_14.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("outputDir", context.outputDir);
                    paraList_tRunJob_14.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("outputPath", context.outputPath);
                    paraList_tRunJob_14.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_14.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("tempDir", context.tempDir);
                    paraList_tRunJob_14.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("tempPath", context.tempPath);
                    paraList_tRunJob_14.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_14.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_14.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_14.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_14.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_14().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_14 = context.propertyNames();
		while (propertyNames_tRunJob_14.hasMoreElements()) {
			String key_tRunJob_14 = (String) propertyNames_tRunJob_14.nextElement();
			Object value_tRunJob_14 = (Object) context.get(key_tRunJob_14);
			if(value_tRunJob_14!=null) {  
				paraList_tRunJob_14.add("--context_param " + key_tRunJob_14 + "=" + value_tRunJob_14);
			} else {
				paraList_tRunJob_14.add("--context_param " + key_tRunJob_14 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_14 = null;

	
	
		com_casus_where2test_migration.importcasessachsengemeindeweekly_0_1.ImportCasesSachsenGemeindeWeekly childJob_tRunJob_14 = new com_casus_where2test_migration.importcasessachsengemeindeweekly_0_1.ImportCasesSachsenGemeindeWeekly();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_14 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_14) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_14 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_14 : talendDataSources_tRunJob_14
			        .entrySet()) {
	            dataSources_tRunJob_14.put(talendDataSourceEntry_tRunJob_14.getKey(),
	                    talendDataSourceEntry_tRunJob_14.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_14.setDataSources(dataSources_tRunJob_14);
	    }
		  
			childJob_tRunJob_14.parentContextMap = parentContextMap_tRunJob_14;
		  
		
		String[][] childReturn_tRunJob_14 = childJob_tRunJob_14.runJob((String[]) paraList_tRunJob_14.toArray(new String[paraList_tRunJob_14.size()]));
		
            if(childJob_tRunJob_14.getErrorCode() == null){
                globalMap.put("tRunJob_14_CHILD_RETURN_CODE", childJob_tRunJob_14.getStatus() != null && ("failure").equals(childJob_tRunJob_14.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_14_CHILD_RETURN_CODE", childJob_tRunJob_14.getErrorCode());
            }
            if (childJob_tRunJob_14.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_14_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_14.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_14.getErrorCode();
                if (childJob_tRunJob_14.getErrorCode() != null || ("failure").equals(childJob_tRunJob_14.getStatus())) {
                    java.lang.Exception ce_tRunJob_14 = childJob_tRunJob_14.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_14!=null) ? (ce_tRunJob_14.getClass().getName() + ": " + ce_tRunJob_14.getMessage()) : ""));
                }

 


	tos_count_tRunJob_14++;

/**
 * [tRunJob_14 main ] stop
 */
	
	/**
	 * [tRunJob_14 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_14";

	

 



/**
 * [tRunJob_14 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_14 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_14";

	

 



/**
 * [tRunJob_14 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_14 end ] start
	 */

	

	
	
	currentComponent="tRunJob_14";

	

 

ok_Hash.put("tRunJob_14", true);
end_Hash.put("tRunJob_14", System.currentTimeMillis());




/**
 * [tRunJob_14 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_14 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_14";

	

 



/**
 * [tRunJob_14 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_14_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_5Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_5_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_5 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_5", false);
		start_Hash.put("tRunJob_5", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_5";

	
		int tos_count_tRunJob_5 = 0;
		


 



/**
 * [tRunJob_5 begin ] stop
 */
	
	/**
	 * [tRunJob_5 main ] start
	 */

	

	
	
	currentComponent="tRunJob_5";

	
	java.util.List<String> paraList_tRunJob_5 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_5.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_5.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_5.add("--father_node=tRunJob_5");
	      			
	        			paraList_tRunJob_5.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_5.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_5.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_5.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_5 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_5 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_5".equals(tRunJobName_tRunJob_5) && childResumePath_tRunJob_5 != null){
		paraList_tRunJob_5.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_5.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_5");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_5 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_5 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_5.put("application", context.application);
                    paraList_tRunJob_5.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_5.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_5.put("parentMap", context.parentMap);
                    paraList_tRunJob_5.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_5.put("rootPath", context.rootPath);
                    paraList_tRunJob_5.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_5.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_5.put("default_user", context.default_user);
                    paraList_tRunJob_5.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_5.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("inputDir", context.inputDir);
                    paraList_tRunJob_5.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("inputPath", context.inputPath);
                    paraList_tRunJob_5.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("logDir", context.logDir);
                    paraList_tRunJob_5.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("logPath", context.logPath);
                    paraList_tRunJob_5.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_5.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("outputDir", context.outputDir);
                    paraList_tRunJob_5.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("outputPath", context.outputPath);
                    paraList_tRunJob_5.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_5.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("tempDir", context.tempDir);
                    paraList_tRunJob_5.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("tempPath", context.tempPath);
                    paraList_tRunJob_5.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_5.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_5.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_5.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_5.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_5().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_5 = context.propertyNames();
		while (propertyNames_tRunJob_5.hasMoreElements()) {
			String key_tRunJob_5 = (String) propertyNames_tRunJob_5.nextElement();
			Object value_tRunJob_5 = (Object) context.get(key_tRunJob_5);
			if(value_tRunJob_5!=null) {  
				paraList_tRunJob_5.add("--context_param " + key_tRunJob_5 + "=" + value_tRunJob_5);
			} else {
				paraList_tRunJob_5.add("--context_param " + key_tRunJob_5 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_5 = null;

	
	
		com_casus_where2test_migration.importinfecteddresdenhospitaldaily_0_1.ImportInfectedDresdenHospitalDaily childJob_tRunJob_5 = new com_casus_where2test_migration.importinfecteddresdenhospitaldaily_0_1.ImportInfectedDresdenHospitalDaily();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_5 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_5) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_5 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_5 : talendDataSources_tRunJob_5
			        .entrySet()) {
	            dataSources_tRunJob_5.put(talendDataSourceEntry_tRunJob_5.getKey(),
	                    talendDataSourceEntry_tRunJob_5.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_5.setDataSources(dataSources_tRunJob_5);
	    }
		  
			childJob_tRunJob_5.parentContextMap = parentContextMap_tRunJob_5;
		  
		
		String[][] childReturn_tRunJob_5 = childJob_tRunJob_5.runJob((String[]) paraList_tRunJob_5.toArray(new String[paraList_tRunJob_5.size()]));
		
            if(childJob_tRunJob_5.getErrorCode() == null){
                globalMap.put("tRunJob_5_CHILD_RETURN_CODE", childJob_tRunJob_5.getStatus() != null && ("failure").equals(childJob_tRunJob_5.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_5_CHILD_RETURN_CODE", childJob_tRunJob_5.getErrorCode());
            }
            if (childJob_tRunJob_5.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_5_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_5.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_5.getErrorCode();
                if (childJob_tRunJob_5.getErrorCode() != null || ("failure").equals(childJob_tRunJob_5.getStatus())) {
                    java.lang.Exception ce_tRunJob_5 = childJob_tRunJob_5.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_5!=null) ? (ce_tRunJob_5.getClass().getName() + ": " + ce_tRunJob_5.getMessage()) : ""));
                }

 


	tos_count_tRunJob_5++;

/**
 * [tRunJob_5 main ] stop
 */
	
	/**
	 * [tRunJob_5 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_5";

	

 



/**
 * [tRunJob_5 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_5 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_5";

	

 



/**
 * [tRunJob_5 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_5 end ] start
	 */

	

	
	
	currentComponent="tRunJob_5";

	

 

ok_Hash.put("tRunJob_5", true);
end_Hash.put("tRunJob_5", System.currentTimeMillis());




/**
 * [tRunJob_5 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_5:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk7", 0, "ok");
								} 
							
							tRunJob_6Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_5 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_5";

	

 



/**
 * [tRunJob_5 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_5_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_6Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_6_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_6 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_6", false);
		start_Hash.put("tRunJob_6", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_6";

	
		int tos_count_tRunJob_6 = 0;
		


 



/**
 * [tRunJob_6 begin ] stop
 */
	
	/**
	 * [tRunJob_6 main ] start
	 */

	

	
	
	currentComponent="tRunJob_6";

	
	java.util.List<String> paraList_tRunJob_6 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_6.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_6.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_6.add("--father_node=tRunJob_6");
	      			
	        			paraList_tRunJob_6.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_6.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_6.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_6.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_6 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_6 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_6".equals(tRunJobName_tRunJob_6) && childResumePath_tRunJob_6 != null){
		paraList_tRunJob_6.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_6.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_6");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_6 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_6 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_6.put("application", context.application);
                    paraList_tRunJob_6.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_6.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_6.put("parentMap", context.parentMap);
                    paraList_tRunJob_6.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_6.put("rootPath", context.rootPath);
                    paraList_tRunJob_6.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_6.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_6.put("default_user", context.default_user);
                    paraList_tRunJob_6.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_6.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("inputDir", context.inputDir);
                    paraList_tRunJob_6.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("inputPath", context.inputPath);
                    paraList_tRunJob_6.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("logDir", context.logDir);
                    paraList_tRunJob_6.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("logPath", context.logPath);
                    paraList_tRunJob_6.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_6.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("outputDir", context.outputDir);
                    paraList_tRunJob_6.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("outputPath", context.outputPath);
                    paraList_tRunJob_6.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_6.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("tempDir", context.tempDir);
                    paraList_tRunJob_6.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("tempPath", context.tempPath);
                    paraList_tRunJob_6.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_6.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_6.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_6.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_6.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_6().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_6 = context.propertyNames();
		while (propertyNames_tRunJob_6.hasMoreElements()) {
			String key_tRunJob_6 = (String) propertyNames_tRunJob_6.nextElement();
			Object value_tRunJob_6 = (Object) context.get(key_tRunJob_6);
			if(value_tRunJob_6!=null) {  
				paraList_tRunJob_6.add("--context_param " + key_tRunJob_6 + "=" + value_tRunJob_6);
			} else {
				paraList_tRunJob_6.add("--context_param " + key_tRunJob_6 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_6 = null;

	
	
		com_casus_where2test_migration.importinfectedhospitalizeddresdendaily_0_1.ImportInfectedHospitalizedDresdenDaily childJob_tRunJob_6 = new com_casus_where2test_migration.importinfectedhospitalizeddresdendaily_0_1.ImportInfectedHospitalizedDresdenDaily();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_6 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_6) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_6 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_6 : talendDataSources_tRunJob_6
			        .entrySet()) {
	            dataSources_tRunJob_6.put(talendDataSourceEntry_tRunJob_6.getKey(),
	                    talendDataSourceEntry_tRunJob_6.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_6.setDataSources(dataSources_tRunJob_6);
	    }
		  
			childJob_tRunJob_6.parentContextMap = parentContextMap_tRunJob_6;
		  
		
		String[][] childReturn_tRunJob_6 = childJob_tRunJob_6.runJob((String[]) paraList_tRunJob_6.toArray(new String[paraList_tRunJob_6.size()]));
		
            if(childJob_tRunJob_6.getErrorCode() == null){
                globalMap.put("tRunJob_6_CHILD_RETURN_CODE", childJob_tRunJob_6.getStatus() != null && ("failure").equals(childJob_tRunJob_6.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_6_CHILD_RETURN_CODE", childJob_tRunJob_6.getErrorCode());
            }
            if (childJob_tRunJob_6.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_6_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_6.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_6.getErrorCode();
                if (childJob_tRunJob_6.getErrorCode() != null || ("failure").equals(childJob_tRunJob_6.getStatus())) {
                    java.lang.Exception ce_tRunJob_6 = childJob_tRunJob_6.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_6!=null) ? (ce_tRunJob_6.getClass().getName() + ": " + ce_tRunJob_6.getMessage()) : ""));
                }

 


	tos_count_tRunJob_6++;

/**
 * [tRunJob_6 main ] stop
 */
	
	/**
	 * [tRunJob_6 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_6";

	

 



/**
 * [tRunJob_6 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_6 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_6";

	

 



/**
 * [tRunJob_6 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_6 end ] start
	 */

	

	
	
	currentComponent="tRunJob_6";

	

 

ok_Hash.put("tRunJob_6", true);
end_Hash.put("tRunJob_6", System.currentTimeMillis());




/**
 * [tRunJob_6 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_6:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk8", 0, "ok");
								} 
							
							tRunJob_7Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_6 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_6";

	

 



/**
 * [tRunJob_6 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_6_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_7Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_7_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_7 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_7", false);
		start_Hash.put("tRunJob_7", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_7";

	
		int tos_count_tRunJob_7 = 0;
		


 



/**
 * [tRunJob_7 begin ] stop
 */
	
	/**
	 * [tRunJob_7 main ] start
	 */

	

	
	
	currentComponent="tRunJob_7";

	
	java.util.List<String> paraList_tRunJob_7 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_7.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_7.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_7.add("--father_node=tRunJob_7");
	      			
	        			paraList_tRunJob_7.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_7.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_7.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_7.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_7 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_7 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_7".equals(tRunJobName_tRunJob_7) && childResumePath_tRunJob_7 != null){
		paraList_tRunJob_7.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_7.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_7");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_7 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_7 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_7.put("application", context.application);
                    paraList_tRunJob_7.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_7.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_7.put("parentMap", context.parentMap);
                    paraList_tRunJob_7.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_7.put("rootPath", context.rootPath);
                    paraList_tRunJob_7.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_7.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_7.put("default_user", context.default_user);
                    paraList_tRunJob_7.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_7.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("inputDir", context.inputDir);
                    paraList_tRunJob_7.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("inputPath", context.inputPath);
                    paraList_tRunJob_7.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("logDir", context.logDir);
                    paraList_tRunJob_7.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("logPath", context.logPath);
                    paraList_tRunJob_7.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_7.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("outputDir", context.outputDir);
                    paraList_tRunJob_7.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("outputPath", context.outputPath);
                    paraList_tRunJob_7.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_7.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("tempDir", context.tempDir);
                    paraList_tRunJob_7.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("tempPath", context.tempPath);
                    paraList_tRunJob_7.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_7.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_7.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_7.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_7.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_7().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_7 = context.propertyNames();
		while (propertyNames_tRunJob_7.hasMoreElements()) {
			String key_tRunJob_7 = (String) propertyNames_tRunJob_7.nextElement();
			Object value_tRunJob_7 = (Object) context.get(key_tRunJob_7);
			if(value_tRunJob_7!=null) {  
				paraList_tRunJob_7.add("--context_param " + key_tRunJob_7 + "=" + value_tRunJob_7);
			} else {
				paraList_tRunJob_7.add("--context_param " + key_tRunJob_7 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_7 = null;

	
	
		com_casus_where2test_migration.importdeaddresdenhospitaldaily_0_1.ImportDeadDresdenHospitalDaily childJob_tRunJob_7 = new com_casus_where2test_migration.importdeaddresdenhospitaldaily_0_1.ImportDeadDresdenHospitalDaily();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_7 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_7) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_7 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_7 : talendDataSources_tRunJob_7
			        .entrySet()) {
	            dataSources_tRunJob_7.put(talendDataSourceEntry_tRunJob_7.getKey(),
	                    talendDataSourceEntry_tRunJob_7.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_7.setDataSources(dataSources_tRunJob_7);
	    }
		  
			childJob_tRunJob_7.parentContextMap = parentContextMap_tRunJob_7;
		  
		
		String[][] childReturn_tRunJob_7 = childJob_tRunJob_7.runJob((String[]) paraList_tRunJob_7.toArray(new String[paraList_tRunJob_7.size()]));
		
            if(childJob_tRunJob_7.getErrorCode() == null){
                globalMap.put("tRunJob_7_CHILD_RETURN_CODE", childJob_tRunJob_7.getStatus() != null && ("failure").equals(childJob_tRunJob_7.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_7_CHILD_RETURN_CODE", childJob_tRunJob_7.getErrorCode());
            }
            if (childJob_tRunJob_7.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_7_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_7.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_7.getErrorCode();
                if (childJob_tRunJob_7.getErrorCode() != null || ("failure").equals(childJob_tRunJob_7.getStatus())) {
                    java.lang.Exception ce_tRunJob_7 = childJob_tRunJob_7.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_7!=null) ? (ce_tRunJob_7.getClass().getName() + ": " + ce_tRunJob_7.getMessage()) : ""));
                }

 


	tos_count_tRunJob_7++;

/**
 * [tRunJob_7 main ] stop
 */
	
	/**
	 * [tRunJob_7 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_7";

	

 



/**
 * [tRunJob_7 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_7 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_7";

	

 



/**
 * [tRunJob_7 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_7 end ] start
	 */

	

	
	
	currentComponent="tRunJob_7";

	

 

ok_Hash.put("tRunJob_7", true);
end_Hash.put("tRunJob_7", System.currentTimeMillis());




/**
 * [tRunJob_7 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_7:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk9", 0, "ok");
								} 
							
							tRunJob_8Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_7 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_7";

	

 



/**
 * [tRunJob_7 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_7_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_8Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_8_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_8 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_8", false);
		start_Hash.put("tRunJob_8", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_8";

	
		int tos_count_tRunJob_8 = 0;
		


 



/**
 * [tRunJob_8 begin ] stop
 */
	
	/**
	 * [tRunJob_8 main ] start
	 */

	

	
	
	currentComponent="tRunJob_8";

	
	java.util.List<String> paraList_tRunJob_8 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_8.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_8.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_8.add("--father_node=tRunJob_8");
	      			
	        			paraList_tRunJob_8.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_8.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_8.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_8.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_8 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_8 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_8".equals(tRunJobName_tRunJob_8) && childResumePath_tRunJob_8 != null){
		paraList_tRunJob_8.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_8.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_8");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_8 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_8 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_8.put("application", context.application);
                    paraList_tRunJob_8.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_8.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_8.put("parentMap", context.parentMap);
                    paraList_tRunJob_8.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_8.put("rootPath", context.rootPath);
                    paraList_tRunJob_8.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_8.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_8.put("default_user", context.default_user);
                    paraList_tRunJob_8.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_8.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("inputDir", context.inputDir);
                    paraList_tRunJob_8.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("inputPath", context.inputPath);
                    paraList_tRunJob_8.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("logDir", context.logDir);
                    paraList_tRunJob_8.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("logPath", context.logPath);
                    paraList_tRunJob_8.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_8.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("outputDir", context.outputDir);
                    paraList_tRunJob_8.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("outputPath", context.outputPath);
                    paraList_tRunJob_8.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_8.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("tempDir", context.tempDir);
                    paraList_tRunJob_8.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("tempPath", context.tempPath);
                    paraList_tRunJob_8.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_8.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_8.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_8.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_8.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_8().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_8 = context.propertyNames();
		while (propertyNames_tRunJob_8.hasMoreElements()) {
			String key_tRunJob_8 = (String) propertyNames_tRunJob_8.nextElement();
			Object value_tRunJob_8 = (Object) context.get(key_tRunJob_8);
			if(value_tRunJob_8!=null) {  
				paraList_tRunJob_8.add("--context_param " + key_tRunJob_8 + "=" + value_tRunJob_8);
			} else {
				paraList_tRunJob_8.add("--context_param " + key_tRunJob_8 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_8 = null;

	
	
		com_casus_where2test_migration.importrecovereddresdenhospitaldaily_0_1.ImportRecoveredDresdenHospitalDaily childJob_tRunJob_8 = new com_casus_where2test_migration.importrecovereddresdenhospitaldaily_0_1.ImportRecoveredDresdenHospitalDaily();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_8 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_8) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_8 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_8 : talendDataSources_tRunJob_8
			        .entrySet()) {
	            dataSources_tRunJob_8.put(talendDataSourceEntry_tRunJob_8.getKey(),
	                    talendDataSourceEntry_tRunJob_8.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_8.setDataSources(dataSources_tRunJob_8);
	    }
		  
			childJob_tRunJob_8.parentContextMap = parentContextMap_tRunJob_8;
		  
		
		String[][] childReturn_tRunJob_8 = childJob_tRunJob_8.runJob((String[]) paraList_tRunJob_8.toArray(new String[paraList_tRunJob_8.size()]));
		
            if(childJob_tRunJob_8.getErrorCode() == null){
                globalMap.put("tRunJob_8_CHILD_RETURN_CODE", childJob_tRunJob_8.getStatus() != null && ("failure").equals(childJob_tRunJob_8.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_8_CHILD_RETURN_CODE", childJob_tRunJob_8.getErrorCode());
            }
            if (childJob_tRunJob_8.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_8_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_8.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_8.getErrorCode();
                if (childJob_tRunJob_8.getErrorCode() != null || ("failure").equals(childJob_tRunJob_8.getStatus())) {
                    java.lang.Exception ce_tRunJob_8 = childJob_tRunJob_8.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_8!=null) ? (ce_tRunJob_8.getClass().getName() + ": " + ce_tRunJob_8.getMessage()) : ""));
                }

 


	tos_count_tRunJob_8++;

/**
 * [tRunJob_8 main ] stop
 */
	
	/**
	 * [tRunJob_8 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_8";

	

 



/**
 * [tRunJob_8 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_8 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_8";

	

 



/**
 * [tRunJob_8 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_8 end ] start
	 */

	

	
	
	currentComponent="tRunJob_8";

	

 

ok_Hash.put("tRunJob_8", true);
end_Hash.put("tRunJob_8", System.currentTimeMillis());




/**
 * [tRunJob_8 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_8:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk18", 0, "ok");
								} 
							
							tRunJob_15Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_8 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_8";

	

 



/**
 * [tRunJob_8 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_8_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_15Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_15_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_15 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_15", false);
		start_Hash.put("tRunJob_15", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_15";

	
		int tos_count_tRunJob_15 = 0;
		


 



/**
 * [tRunJob_15 begin ] stop
 */
	
	/**
	 * [tRunJob_15 main ] start
	 */

	

	
	
	currentComponent="tRunJob_15";

	
	java.util.List<String> paraList_tRunJob_15 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_15.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_15.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_15.add("--father_node=tRunJob_15");
	      			
	        			paraList_tRunJob_15.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_15.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_15.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_15.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_15 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_15 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_15".equals(tRunJobName_tRunJob_15) && childResumePath_tRunJob_15 != null){
		paraList_tRunJob_15.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_15.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_15");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_15 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_15 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_15.put("application", context.application);
                    paraList_tRunJob_15.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_15.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_15.put("parentMap", context.parentMap);
                    paraList_tRunJob_15.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_15.put("rootPath", context.rootPath);
                    paraList_tRunJob_15.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_15.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_15.put("default_user", context.default_user);
                    paraList_tRunJob_15.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_15.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("inputDir", context.inputDir);
                    paraList_tRunJob_15.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("inputPath", context.inputPath);
                    paraList_tRunJob_15.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("logDir", context.logDir);
                    paraList_tRunJob_15.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("logPath", context.logPath);
                    paraList_tRunJob_15.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_15.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("outputDir", context.outputDir);
                    paraList_tRunJob_15.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("outputPath", context.outputPath);
                    paraList_tRunJob_15.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_15.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("tempDir", context.tempDir);
                    paraList_tRunJob_15.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("tempPath", context.tempPath);
                    paraList_tRunJob_15.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_15.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_15.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_15.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_15.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_15().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_15 = context.propertyNames();
		while (propertyNames_tRunJob_15.hasMoreElements()) {
			String key_tRunJob_15 = (String) propertyNames_tRunJob_15.nextElement();
			Object value_tRunJob_15 = (Object) context.get(key_tRunJob_15);
			if(value_tRunJob_15!=null) {  
				paraList_tRunJob_15.add("--context_param " + key_tRunJob_15 + "=" + value_tRunJob_15);
			} else {
				paraList_tRunJob_15.add("--context_param " + key_tRunJob_15 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_15 = null;

	
	
		com_casus_where2test_migration.importalphasachsenweekly_0_1.ImportAlphaSachsenWeekly childJob_tRunJob_15 = new com_casus_where2test_migration.importalphasachsenweekly_0_1.ImportAlphaSachsenWeekly();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_15 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_15) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_15 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_15 : talendDataSources_tRunJob_15
			        .entrySet()) {
	            dataSources_tRunJob_15.put(talendDataSourceEntry_tRunJob_15.getKey(),
	                    talendDataSourceEntry_tRunJob_15.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_15.setDataSources(dataSources_tRunJob_15);
	    }
		  
			childJob_tRunJob_15.parentContextMap = parentContextMap_tRunJob_15;
		  
		
		String[][] childReturn_tRunJob_15 = childJob_tRunJob_15.runJob((String[]) paraList_tRunJob_15.toArray(new String[paraList_tRunJob_15.size()]));
		
            if(childJob_tRunJob_15.getErrorCode() == null){
                globalMap.put("tRunJob_15_CHILD_RETURN_CODE", childJob_tRunJob_15.getStatus() != null && ("failure").equals(childJob_tRunJob_15.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_15_CHILD_RETURN_CODE", childJob_tRunJob_15.getErrorCode());
            }
            if (childJob_tRunJob_15.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_15_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_15.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_15.getErrorCode();
                if (childJob_tRunJob_15.getErrorCode() != null || ("failure").equals(childJob_tRunJob_15.getStatus())) {
                    java.lang.Exception ce_tRunJob_15 = childJob_tRunJob_15.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_15!=null) ? (ce_tRunJob_15.getClass().getName() + ": " + ce_tRunJob_15.getMessage()) : ""));
                }

 


	tos_count_tRunJob_15++;

/**
 * [tRunJob_15 main ] stop
 */
	
	/**
	 * [tRunJob_15 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_15";

	

 



/**
 * [tRunJob_15 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_15 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_15";

	

 



/**
 * [tRunJob_15 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_15 end ] start
	 */

	

	
	
	currentComponent="tRunJob_15";

	

 

ok_Hash.put("tRunJob_15", true);
end_Hash.put("tRunJob_15", System.currentTimeMillis());




/**
 * [tRunJob_15 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_15:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk19", 0, "ok");
								} 
							
							tRunJob_16Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_15 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_15";

	

 



/**
 * [tRunJob_15 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_15_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_16Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_16_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_16 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_16", false);
		start_Hash.put("tRunJob_16", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_16";

	
		int tos_count_tRunJob_16 = 0;
		


 



/**
 * [tRunJob_16 begin ] stop
 */
	
	/**
	 * [tRunJob_16 main ] start
	 */

	

	
	
	currentComponent="tRunJob_16";

	
	java.util.List<String> paraList_tRunJob_16 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_16.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_16.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_16.add("--father_node=tRunJob_16");
	      			
	        			paraList_tRunJob_16.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_16.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_16.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_16.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_16 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_16 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_16".equals(tRunJobName_tRunJob_16) && childResumePath_tRunJob_16 != null){
		paraList_tRunJob_16.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_16.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_16");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_16 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_16 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_16.put("application", context.application);
                    paraList_tRunJob_16.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_16.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_16.put("parentMap", context.parentMap);
                    paraList_tRunJob_16.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_16.put("rootPath", context.rootPath);
                    paraList_tRunJob_16.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_16.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_16.put("default_user", context.default_user);
                    paraList_tRunJob_16.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_16.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("inputDir", context.inputDir);
                    paraList_tRunJob_16.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("inputPath", context.inputPath);
                    paraList_tRunJob_16.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("logDir", context.logDir);
                    paraList_tRunJob_16.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("logPath", context.logPath);
                    paraList_tRunJob_16.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_16.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("outputDir", context.outputDir);
                    paraList_tRunJob_16.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("outputPath", context.outputPath);
                    paraList_tRunJob_16.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_16.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("tempDir", context.tempDir);
                    paraList_tRunJob_16.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("tempPath", context.tempPath);
                    paraList_tRunJob_16.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_16.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_16.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_16.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_16.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_16().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_16 = context.propertyNames();
		while (propertyNames_tRunJob_16.hasMoreElements()) {
			String key_tRunJob_16 = (String) propertyNames_tRunJob_16.nextElement();
			Object value_tRunJob_16 = (Object) context.get(key_tRunJob_16);
			if(value_tRunJob_16!=null) {  
				paraList_tRunJob_16.add("--context_param " + key_tRunJob_16 + "=" + value_tRunJob_16);
			} else {
				paraList_tRunJob_16.add("--context_param " + key_tRunJob_16 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_16 = null;

	
	
		com_casus_where2test_migration.importbetasachsenweekly_0_1.ImportBetaSachsenWeekly childJob_tRunJob_16 = new com_casus_where2test_migration.importbetasachsenweekly_0_1.ImportBetaSachsenWeekly();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_16 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_16) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_16 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_16 : talendDataSources_tRunJob_16
			        .entrySet()) {
	            dataSources_tRunJob_16.put(talendDataSourceEntry_tRunJob_16.getKey(),
	                    talendDataSourceEntry_tRunJob_16.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_16.setDataSources(dataSources_tRunJob_16);
	    }
		  
			childJob_tRunJob_16.parentContextMap = parentContextMap_tRunJob_16;
		  
		
		String[][] childReturn_tRunJob_16 = childJob_tRunJob_16.runJob((String[]) paraList_tRunJob_16.toArray(new String[paraList_tRunJob_16.size()]));
		
            if(childJob_tRunJob_16.getErrorCode() == null){
                globalMap.put("tRunJob_16_CHILD_RETURN_CODE", childJob_tRunJob_16.getStatus() != null && ("failure").equals(childJob_tRunJob_16.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_16_CHILD_RETURN_CODE", childJob_tRunJob_16.getErrorCode());
            }
            if (childJob_tRunJob_16.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_16_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_16.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_16.getErrorCode();
                if (childJob_tRunJob_16.getErrorCode() != null || ("failure").equals(childJob_tRunJob_16.getStatus())) {
                    java.lang.Exception ce_tRunJob_16 = childJob_tRunJob_16.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_16!=null) ? (ce_tRunJob_16.getClass().getName() + ": " + ce_tRunJob_16.getMessage()) : ""));
                }

 


	tos_count_tRunJob_16++;

/**
 * [tRunJob_16 main ] stop
 */
	
	/**
	 * [tRunJob_16 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_16";

	

 



/**
 * [tRunJob_16 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_16 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_16";

	

 



/**
 * [tRunJob_16 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_16 end ] start
	 */

	

	
	
	currentComponent="tRunJob_16";

	

 

ok_Hash.put("tRunJob_16", true);
end_Hash.put("tRunJob_16", System.currentTimeMillis());




/**
 * [tRunJob_16 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_16:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk20", 0, "ok");
								} 
							
							tRunJob_17Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_16 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_16";

	

 



/**
 * [tRunJob_16 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_16_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_17Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_17_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_17 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_17", false);
		start_Hash.put("tRunJob_17", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_17";

	
		int tos_count_tRunJob_17 = 0;
		


 



/**
 * [tRunJob_17 begin ] stop
 */
	
	/**
	 * [tRunJob_17 main ] start
	 */

	

	
	
	currentComponent="tRunJob_17";

	
	java.util.List<String> paraList_tRunJob_17 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_17.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_17.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_17.add("--father_node=tRunJob_17");
	      			
	        			paraList_tRunJob_17.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_17.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_17.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_17.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_17 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_17 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_17".equals(tRunJobName_tRunJob_17) && childResumePath_tRunJob_17 != null){
		paraList_tRunJob_17.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_17.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_17");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_17 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_17 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_17.put("application", context.application);
                    paraList_tRunJob_17.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_17.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_17.put("parentMap", context.parentMap);
                    paraList_tRunJob_17.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_17.put("rootPath", context.rootPath);
                    paraList_tRunJob_17.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_17.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_17.put("default_user", context.default_user);
                    paraList_tRunJob_17.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_17.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("inputDir", context.inputDir);
                    paraList_tRunJob_17.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("inputPath", context.inputPath);
                    paraList_tRunJob_17.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("logDir", context.logDir);
                    paraList_tRunJob_17.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("logPath", context.logPath);
                    paraList_tRunJob_17.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_17.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("outputDir", context.outputDir);
                    paraList_tRunJob_17.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("outputPath", context.outputPath);
                    paraList_tRunJob_17.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_17.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("tempDir", context.tempDir);
                    paraList_tRunJob_17.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("tempPath", context.tempPath);
                    paraList_tRunJob_17.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_17.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_17.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_17.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_17.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_17().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_17 = context.propertyNames();
		while (propertyNames_tRunJob_17.hasMoreElements()) {
			String key_tRunJob_17 = (String) propertyNames_tRunJob_17.nextElement();
			Object value_tRunJob_17 = (Object) context.get(key_tRunJob_17);
			if(value_tRunJob_17!=null) {  
				paraList_tRunJob_17.add("--context_param " + key_tRunJob_17 + "=" + value_tRunJob_17);
			} else {
				paraList_tRunJob_17.add("--context_param " + key_tRunJob_17 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_17 = null;

	
	
		com_casus_where2test_migration.importdeltasachsenweekly_0_1.ImportDeltaSachsenWeekly childJob_tRunJob_17 = new com_casus_where2test_migration.importdeltasachsenweekly_0_1.ImportDeltaSachsenWeekly();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_17 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_17) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_17 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_17 : talendDataSources_tRunJob_17
			        .entrySet()) {
	            dataSources_tRunJob_17.put(talendDataSourceEntry_tRunJob_17.getKey(),
	                    talendDataSourceEntry_tRunJob_17.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_17.setDataSources(dataSources_tRunJob_17);
	    }
		  
			childJob_tRunJob_17.parentContextMap = parentContextMap_tRunJob_17;
		  
		
		String[][] childReturn_tRunJob_17 = childJob_tRunJob_17.runJob((String[]) paraList_tRunJob_17.toArray(new String[paraList_tRunJob_17.size()]));
		
            if(childJob_tRunJob_17.getErrorCode() == null){
                globalMap.put("tRunJob_17_CHILD_RETURN_CODE", childJob_tRunJob_17.getStatus() != null && ("failure").equals(childJob_tRunJob_17.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_17_CHILD_RETURN_CODE", childJob_tRunJob_17.getErrorCode());
            }
            if (childJob_tRunJob_17.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_17_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_17.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_17.getErrorCode();
                if (childJob_tRunJob_17.getErrorCode() != null || ("failure").equals(childJob_tRunJob_17.getStatus())) {
                    java.lang.Exception ce_tRunJob_17 = childJob_tRunJob_17.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_17!=null) ? (ce_tRunJob_17.getClass().getName() + ": " + ce_tRunJob_17.getMessage()) : ""));
                }

 


	tos_count_tRunJob_17++;

/**
 * [tRunJob_17 main ] stop
 */
	
	/**
	 * [tRunJob_17 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_17";

	

 



/**
 * [tRunJob_17 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_17 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_17";

	

 



/**
 * [tRunJob_17 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_17 end ] start
	 */

	

	
	
	currentComponent="tRunJob_17";

	

 

ok_Hash.put("tRunJob_17", true);
end_Hash.put("tRunJob_17", System.currentTimeMillis());




/**
 * [tRunJob_17 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_17:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk21", 0, "ok");
								} 
							
							tRunJob_18Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_17 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_17";

	

 



/**
 * [tRunJob_17 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_17_SUBPROCESS_STATE", 1);
	}
	

public void tRunJob_18Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_18_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;





	
	/**
	 * [tRunJob_18 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_18", false);
		start_Hash.put("tRunJob_18", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_18";

	
		int tos_count_tRunJob_18 = 0;
		


 



/**
 * [tRunJob_18 begin ] stop
 */
	
	/**
	 * [tRunJob_18 main ] start
	 */

	

	
	
	currentComponent="tRunJob_18";

	
	java.util.List<String> paraList_tRunJob_18 = new java.util.ArrayList<String>();
	
	        			paraList_tRunJob_18.add("--father_pid="+pid);
	      			
	        			paraList_tRunJob_18.add("--root_pid="+rootPid);
	      			
	        			paraList_tRunJob_18.add("--father_node=tRunJob_18");
	      			
	        			paraList_tRunJob_18.add("--context=Test");
	      			
		if(enableLogStash){
			paraList_tRunJob_18.add("--monitoring="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_18.add("--stat_port=" + portStats);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_18.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_18 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_18 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_18".equals(tRunJobName_tRunJob_18) && childResumePath_tRunJob_18 != null){
		paraList_tRunJob_18.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_18.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_18");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_18 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_18 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_18.put("application", context.application);
                    paraList_tRunJob_18.add("--context_type " + "application" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("cleanDBOn", context.cleanDBOn);
                    paraList_tRunJob_18.add("--context_type " + "cleanDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_18.put("parentMap", context.parentMap);
                    paraList_tRunJob_18.add("--context_type " + "parentMap" + "=" + "id_Object");
                    parentContextMap_tRunJob_18.put("rootPath", context.rootPath);
                    paraList_tRunJob_18.add("--context_type " + "rootPath" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("syncDBOn", context.syncDBOn);
                    paraList_tRunJob_18.add("--context_type " + "syncDBOn" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_18.put("default_user", context.default_user);
                    paraList_tRunJob_18.add("--context_type " + "default_user" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("errorLogFile", context.errorLogFile);
                    paraList_tRunJob_18.add("--context_type " + "errorLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("inputDir", context.inputDir);
                    paraList_tRunJob_18.add("--context_type " + "inputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("inputPath", context.inputPath);
                    paraList_tRunJob_18.add("--context_type " + "inputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("logDir", context.logDir);
                    paraList_tRunJob_18.add("--context_type " + "logDir" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("logPath", context.logPath);
                    paraList_tRunJob_18.add("--context_type " + "logPath" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("migrationLogFile", context.migrationLogFile);
                    paraList_tRunJob_18.add("--context_type " + "migrationLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("outputDir", context.outputDir);
                    paraList_tRunJob_18.add("--context_type " + "outputDir" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("outputPath", context.outputPath);
                    paraList_tRunJob_18.add("--context_type " + "outputPath" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("rowLogFile", context.rowLogFile);
                    paraList_tRunJob_18.add("--context_type " + "rowLogFile" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("tempDir", context.tempDir);
                    paraList_tRunJob_18.add("--context_type " + "tempDir" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("tempPath", context.tempPath);
                    paraList_tRunJob_18.add("--context_type " + "tempPath" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("writeToDB", context.writeToDB);
                    paraList_tRunJob_18.add("--context_type " + "writeToDB" + "=" + "id_Boolean");
                    parentContextMap_tRunJob_18.put("w2tpostgre_AdditionalParams", context.w2tpostgre_AdditionalParams);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_AdditionalParams" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Database", context.w2tpostgre_Database);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Database" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Login", context.w2tpostgre_Login);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Login" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Password", context.w2tpostgre_Password);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Password" + "=" + "id_Password");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Port", context.w2tpostgre_Port);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Port" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Schema", context.w2tpostgre_Schema);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Schema" + "=" + "id_String");
                    parentContextMap_tRunJob_18.put("w2tpostgre_Server", context.w2tpostgre_Server);
                    paraList_tRunJob_18.add("--context_type " + "w2tpostgre_Server" + "=" + "id_String");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_18().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_18 = context.propertyNames();
		while (propertyNames_tRunJob_18.hasMoreElements()) {
			String key_tRunJob_18 = (String) propertyNames_tRunJob_18.nextElement();
			Object value_tRunJob_18 = (Object) context.get(key_tRunJob_18);
			if(value_tRunJob_18!=null) {  
				paraList_tRunJob_18.add("--context_param " + key_tRunJob_18 + "=" + value_tRunJob_18);
			} else {
				paraList_tRunJob_18.add("--context_param " + key_tRunJob_18 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_18 = null;

	
	
		com_casus_where2test_migration.importomicronsachsenweekly_0_1.ImportOmicronSachsenWeekly childJob_tRunJob_18 = new com_casus_where2test_migration.importomicronsachsenweekly_0_1.ImportOmicronSachsenWeekly();
	    // pass DataSources
	    java.util.Map<String, routines.system.TalendDataSource> talendDataSources_tRunJob_18 = (java.util.Map<String, routines.system.TalendDataSource>) globalMap
	            .get(KEY_DB_DATASOURCES);
	    if (null != talendDataSources_tRunJob_18) {
	        java.util.Map<String, javax.sql.DataSource> dataSources_tRunJob_18 = new java.util.HashMap<String, javax.sql.DataSource>();
	        for (java.util.Map.Entry<String, routines.system.TalendDataSource> talendDataSourceEntry_tRunJob_18 : talendDataSources_tRunJob_18
			        .entrySet()) {
	            dataSources_tRunJob_18.put(talendDataSourceEntry_tRunJob_18.getKey(),
	                    talendDataSourceEntry_tRunJob_18.getValue().getRawDataSource());
	        }
	        childJob_tRunJob_18.setDataSources(dataSources_tRunJob_18);
	    }
		  
			childJob_tRunJob_18.parentContextMap = parentContextMap_tRunJob_18;
		  
		
		String[][] childReturn_tRunJob_18 = childJob_tRunJob_18.runJob((String[]) paraList_tRunJob_18.toArray(new String[paraList_tRunJob_18.size()]));
		
            if(childJob_tRunJob_18.getErrorCode() == null){
                globalMap.put("tRunJob_18_CHILD_RETURN_CODE", childJob_tRunJob_18.getStatus() != null && ("failure").equals(childJob_tRunJob_18.getStatus()) ? 1 : 0);
            }else{
                globalMap.put("tRunJob_18_CHILD_RETURN_CODE", childJob_tRunJob_18.getErrorCode());
            }
            if (childJob_tRunJob_18.getExceptionStackTrace() != null) {
                globalMap.put("tRunJob_18_CHILD_EXCEPTION_STACKTRACE", childJob_tRunJob_18.getExceptionStackTrace());
            }
                    errorCode = childJob_tRunJob_18.getErrorCode();
                if (childJob_tRunJob_18.getErrorCode() != null || ("failure").equals(childJob_tRunJob_18.getStatus())) {
                    java.lang.Exception ce_tRunJob_18 = childJob_tRunJob_18.getException();
                    throw new RuntimeException("Child job running failed.\n" + ((ce_tRunJob_18!=null) ? (ce_tRunJob_18.getClass().getName() + ": " + ce_tRunJob_18.getMessage()) : ""));
                }

 


	tos_count_tRunJob_18++;

/**
 * [tRunJob_18 main ] stop
 */
	
	/**
	 * [tRunJob_18 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_18";

	

 



/**
 * [tRunJob_18 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_18 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_18";

	

 



/**
 * [tRunJob_18 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_18 end ] start
	 */

	

	
	
	currentComponent="tRunJob_18";

	

 

ok_Hash.put("tRunJob_18", true);
end_Hash.put("tRunJob_18", System.currentTimeMillis());




/**
 * [tRunJob_18 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_18 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_18";

	

 



/**
 * [tRunJob_18 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_18_SUBPROCESS_STATE", 1);
	}
	
    public String resuming_logs_dir_path = null;
    public String resuming_checkpoint_path = null;
    public String parent_part_launcher = null;
    private String resumeEntryMethodName = null;
    private boolean globalResumeTicket = false;

    public boolean watch = false;
    // portStats is null, it means don't execute the statistics
    public Integer portStats = null;
    public int portTraces = 4334;
    public String clientHost;
    public String defaultClientHost = "localhost";
    public String contextStr = "Default";
    public boolean isDefaultContext = true;
    public String pid = "0";
    public String rootPid = null;
    public String fatherPid = null;
    public String fatherNode = null;
    public long startTime = 0;
    public boolean isChildJob = false;
    public String log4jLevel = "";
    
    private boolean enableLogStash;

    private boolean execStat = true;

    private ThreadLocal<java.util.Map<String, String>> threadLocal = new ThreadLocal<java.util.Map<String, String>>() {
        protected java.util.Map<String, String> initialValue() {
            java.util.Map<String,String> threadRunResultMap = new java.util.HashMap<String, String>();
            threadRunResultMap.put("errorCode", null);
            threadRunResultMap.put("status", "");
            return threadRunResultMap;
        };
    };


    private PropertiesWithType context_param = new PropertiesWithType();
    public java.util.Map<String, Object> parentContextMap = new java.util.HashMap<String, Object>();

    public String status= "";
    

    public static void main(String[] args){
        final ImportCasesSachsen ImportCasesSachsenClass = new ImportCasesSachsen();

        int exitCode = ImportCasesSachsenClass.runJobInTOS(args);

        System.exit(exitCode);
    }


    public String[][] runJob(String[] args) {

        int exitCode = runJobInTOS(args);
        String[][] bufferValue = new String[][] { { Integer.toString(exitCode) } };

        return bufferValue;
    }

    public boolean hastBufferOutputComponent() {
		boolean hastBufferOutput = false;
    	
        return hastBufferOutput;
    }

    public int runJobInTOS(String[] args) {
	   	// reset status
	   	status = "";
	   	
        String lastStr = "";
        for (String arg : args) {
            if (arg.equalsIgnoreCase("--context_param")) {
                lastStr = arg;
            } else if (lastStr.equals("")) {
                evalParam(arg);
            } else {
                evalParam(lastStr + " " + arg);
                lastStr = "";
            }
        }
        enableLogStash = "true".equalsIgnoreCase(System.getProperty("monitoring"));

    	
    	

        if(clientHost == null) {
            clientHost = defaultClientHost;
        }

        if(pid == null || "0".equals(pid)) {
            pid = TalendString.getAsciiRandomString(6);
        }

        if (rootPid==null) {
            rootPid = pid;
        }
        if (fatherPid==null) {
            fatherPid = pid;
        }else{
            isChildJob = true;
        }

        if (portStats != null) {
            // portStats = -1; //for testing
            if (portStats < 0 || portStats > 65535) {
                // issue:10869, the portStats is invalid, so this client socket can't open
                System.err.println("The statistics socket port " + portStats + " is invalid.");
                execStat = false;
            }
        } else {
            execStat = false;
        }

        try {
            //call job/subjob with an existing context, like: --context=production. if without this parameter, there will use the default context instead.
            java.io.InputStream inContext = ImportCasesSachsen.class.getClassLoader().getResourceAsStream("com_casus_where2test_migration/importcasessachsen_0_1/contexts/" + contextStr + ".properties");
            if (inContext == null) {
                inContext = ImportCasesSachsen.class.getClassLoader().getResourceAsStream("config/contexts/" + contextStr + ".properties");
            }
            if (inContext != null) {
                //defaultProps is in order to keep the original context value
                if(context != null && context.isEmpty()) {
	                defaultProps.load(inContext);
	                context = new ContextProperties(defaultProps);
                }
                
                inContext.close();
            } else if (!isDefaultContext) {
                //print info and job continue to run, for case: context_param is not empty.
                System.err.println("Could not find the context " + contextStr);
            }

            if(!context_param.isEmpty()) {
                context.putAll(context_param);
				//set types for params from parentJobs
				for (Object key: context_param.keySet()){
					String context_key = key.toString();
					String context_type = context_param.getContextType(context_key);
					context.setContextType(context_key, context_type);

				}
            }
            class ContextProcessing {
                private void processContext_0() {
                        context.setContextType("application", "id_String");
                            context.application=(String) context.getProperty("application");
                        context.setContextType("cleanDBOn", "id_Boolean");
                            try{
                                context.cleanDBOn=routines.system.ParserUtils.parseTo_Boolean (context.getProperty("cleanDBOn"));
                            } catch(NumberFormatException e){
                                System.err.println(String.format("Null value will be used for context parameter %s: %s", "cleanDBOn", e.getMessage()));
                                context.cleanDBOn=null;
                            }
                        context.setContextType("parentMap", "id_Object");
                            context.parentMap=(Object) context.getProperty("parentMap");
                        context.setContextType("rootPath", "id_String");
                            context.rootPath=(String) context.getProperty("rootPath");
                        context.setContextType("syncDBOn", "id_Boolean");
                            try{
                                context.syncDBOn=routines.system.ParserUtils.parseTo_Boolean (context.getProperty("syncDBOn"));
                            } catch(NumberFormatException e){
                                System.err.println(String.format("Null value will be used for context parameter %s: %s", "syncDBOn", e.getMessage()));
                                context.syncDBOn=null;
                            }
                        context.setContextType("default_user", "id_String");
                            context.default_user=(String) context.getProperty("default_user");
                        context.setContextType("errorLogFile", "id_String");
                            context.errorLogFile=(String) context.getProperty("errorLogFile");
                        context.setContextType("inputDir", "id_String");
                            context.inputDir=(String) context.getProperty("inputDir");
                        context.setContextType("inputPath", "id_String");
                            context.inputPath=(String) context.getProperty("inputPath");
                        context.setContextType("logDir", "id_String");
                            context.logDir=(String) context.getProperty("logDir");
                        context.setContextType("logPath", "id_String");
                            context.logPath=(String) context.getProperty("logPath");
                        context.setContextType("migrationLogFile", "id_String");
                            context.migrationLogFile=(String) context.getProperty("migrationLogFile");
                        context.setContextType("outputDir", "id_String");
                            context.outputDir=(String) context.getProperty("outputDir");
                        context.setContextType("outputPath", "id_String");
                            context.outputPath=(String) context.getProperty("outputPath");
                        context.setContextType("rowLogFile", "id_String");
                            context.rowLogFile=(String) context.getProperty("rowLogFile");
                        context.setContextType("tempDir", "id_String");
                            context.tempDir=(String) context.getProperty("tempDir");
                        context.setContextType("tempPath", "id_String");
                            context.tempPath=(String) context.getProperty("tempPath");
                        context.setContextType("writeToDB", "id_Boolean");
                            try{
                                context.writeToDB=routines.system.ParserUtils.parseTo_Boolean (context.getProperty("writeToDB"));
                            } catch(NumberFormatException e){
                                System.err.println(String.format("Null value will be used for context parameter %s: %s", "writeToDB", e.getMessage()));
                                context.writeToDB=null;
                            }
                        context.setContextType("w2tpostgre_AdditionalParams", "id_String");
                            context.w2tpostgre_AdditionalParams=(String) context.getProperty("w2tpostgre_AdditionalParams");
                        context.setContextType("w2tpostgre_Database", "id_String");
                            context.w2tpostgre_Database=(String) context.getProperty("w2tpostgre_Database");
                        context.setContextType("w2tpostgre_Login", "id_String");
                            context.w2tpostgre_Login=(String) context.getProperty("w2tpostgre_Login");
                        context.setContextType("w2tpostgre_Password", "id_Password");
                            String pwd_w2tpostgre_Password_value = context.getProperty("w2tpostgre_Password");
                            context.w2tpostgre_Password = null;
                            if(pwd_w2tpostgre_Password_value!=null) {
                                if(context_param.containsKey("w2tpostgre_Password")) {//no need to decrypt if it come from program argument or parent job runtime
                                    context.w2tpostgre_Password = pwd_w2tpostgre_Password_value;
                                } else if (!pwd_w2tpostgre_Password_value.isEmpty()) {
                                    try {
                                        context.w2tpostgre_Password = routines.system.PasswordEncryptUtil.decryptPassword(pwd_w2tpostgre_Password_value);
                                        context.put("w2tpostgre_Password",context.w2tpostgre_Password);
                                    } catch (java.lang.RuntimeException e) {
                                        //do nothing
                                    }
                                }
                            }
                        context.setContextType("w2tpostgre_Port", "id_String");
                            context.w2tpostgre_Port=(String) context.getProperty("w2tpostgre_Port");
                        context.setContextType("w2tpostgre_Schema", "id_String");
                            context.w2tpostgre_Schema=(String) context.getProperty("w2tpostgre_Schema");
                        context.setContextType("w2tpostgre_Server", "id_String");
                            context.w2tpostgre_Server=(String) context.getProperty("w2tpostgre_Server");
                } 
                public void processAllContext() {
                        processContext_0();
                }
            }

            new ContextProcessing().processAllContext();
        } catch (java.io.IOException ie) {
            System.err.println("Could not load context "+contextStr);
            ie.printStackTrace();
        }

        // get context value from parent directly
        if (parentContextMap != null && !parentContextMap.isEmpty()) {if (parentContextMap.containsKey("application")) {
                context.application = (String) parentContextMap.get("application");
            }if (parentContextMap.containsKey("cleanDBOn")) {
                context.cleanDBOn = (Boolean) parentContextMap.get("cleanDBOn");
            }if (parentContextMap.containsKey("parentMap")) {
                context.parentMap = (Object) parentContextMap.get("parentMap");
            }if (parentContextMap.containsKey("rootPath")) {
                context.rootPath = (String) parentContextMap.get("rootPath");
            }if (parentContextMap.containsKey("syncDBOn")) {
                context.syncDBOn = (Boolean) parentContextMap.get("syncDBOn");
            }if (parentContextMap.containsKey("default_user")) {
                context.default_user = (String) parentContextMap.get("default_user");
            }if (parentContextMap.containsKey("errorLogFile")) {
                context.errorLogFile = (String) parentContextMap.get("errorLogFile");
            }if (parentContextMap.containsKey("inputDir")) {
                context.inputDir = (String) parentContextMap.get("inputDir");
            }if (parentContextMap.containsKey("inputPath")) {
                context.inputPath = (String) parentContextMap.get("inputPath");
            }if (parentContextMap.containsKey("logDir")) {
                context.logDir = (String) parentContextMap.get("logDir");
            }if (parentContextMap.containsKey("logPath")) {
                context.logPath = (String) parentContextMap.get("logPath");
            }if (parentContextMap.containsKey("migrationLogFile")) {
                context.migrationLogFile = (String) parentContextMap.get("migrationLogFile");
            }if (parentContextMap.containsKey("outputDir")) {
                context.outputDir = (String) parentContextMap.get("outputDir");
            }if (parentContextMap.containsKey("outputPath")) {
                context.outputPath = (String) parentContextMap.get("outputPath");
            }if (parentContextMap.containsKey("rowLogFile")) {
                context.rowLogFile = (String) parentContextMap.get("rowLogFile");
            }if (parentContextMap.containsKey("tempDir")) {
                context.tempDir = (String) parentContextMap.get("tempDir");
            }if (parentContextMap.containsKey("tempPath")) {
                context.tempPath = (String) parentContextMap.get("tempPath");
            }if (parentContextMap.containsKey("writeToDB")) {
                context.writeToDB = (Boolean) parentContextMap.get("writeToDB");
            }if (parentContextMap.containsKey("w2tpostgre_AdditionalParams")) {
                context.w2tpostgre_AdditionalParams = (String) parentContextMap.get("w2tpostgre_AdditionalParams");
            }if (parentContextMap.containsKey("w2tpostgre_Database")) {
                context.w2tpostgre_Database = (String) parentContextMap.get("w2tpostgre_Database");
            }if (parentContextMap.containsKey("w2tpostgre_Login")) {
                context.w2tpostgre_Login = (String) parentContextMap.get("w2tpostgre_Login");
            }if (parentContextMap.containsKey("w2tpostgre_Password")) {
                context.w2tpostgre_Password = (java.lang.String) parentContextMap.get("w2tpostgre_Password");
            }if (parentContextMap.containsKey("w2tpostgre_Port")) {
                context.w2tpostgre_Port = (String) parentContextMap.get("w2tpostgre_Port");
            }if (parentContextMap.containsKey("w2tpostgre_Schema")) {
                context.w2tpostgre_Schema = (String) parentContextMap.get("w2tpostgre_Schema");
            }if (parentContextMap.containsKey("w2tpostgre_Server")) {
                context.w2tpostgre_Server = (String) parentContextMap.get("w2tpostgre_Server");
            }
        }

        //Resume: init the resumeUtil
        resumeEntryMethodName = ResumeUtil.getResumeEntryMethodName(resuming_checkpoint_path);
        resumeUtil = new ResumeUtil(resuming_logs_dir_path, isChildJob, rootPid);
        resumeUtil.initCommonInfo(pid, rootPid, fatherPid, projectName, jobName, contextStr, jobVersion);

		List<String> parametersToEncrypt = new java.util.ArrayList<String>();
			parametersToEncrypt.add("w2tpostgre_Password");
        //Resume: jobStart
        resumeUtil.addLog("JOB_STARTED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,parametersToEncrypt));

if(execStat) {
    try {
        runStat.openSocket(!isChildJob);
        runStat.setAllPID(rootPid, fatherPid, pid, jobName);
        runStat.startThreadStat(clientHost, portStats);
        runStat.updateStatOnJob(RunStat.JOBSTART, fatherNode);
    } catch (java.io.IOException ioException) {
        ioException.printStackTrace();
    }
}



	
	    java.util.concurrent.ConcurrentHashMap<Object, Object> concurrentHashMap = new java.util.concurrent.ConcurrentHashMap<Object, Object>();
	    globalMap.put("concurrentHashMap", concurrentHashMap);
	

    long startUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
    long endUsedMemory = 0;
    long end = 0;

    startTime = System.currentTimeMillis();




this.globalResumeTicket = true;//to run tPreJob

try {
errorCode = null;tPrejob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPrejob_1) {
globalMap.put("tPrejob_1_SUBPROCESS_STATE", -1);

e_tPrejob_1.printStackTrace();

}



this.globalResumeTicket = false;//to run others jobs

try {
errorCode = null;tRunJob_11Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tRunJob_11) {
globalMap.put("tRunJob_11_SUBPROCESS_STATE", -1);

e_tRunJob_11.printStackTrace();

}
try {
errorCode = null;tRunJob_5Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tRunJob_5) {
globalMap.put("tRunJob_5_SUBPROCESS_STATE", -1);

e_tRunJob_5.printStackTrace();

}

this.globalResumeTicket = true;//to run tPostJob

try {
errorCode = null;tPostjob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPostjob_1) {
globalMap.put("tPostjob_1_SUBPROCESS_STATE", -1);

e_tPostjob_1.printStackTrace();

}



        end = System.currentTimeMillis();

        if (watch) {
            System.out.println((end-startTime)+" milliseconds");
        }

        endUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
        if (false) {
            System.out.println((endUsedMemory - startUsedMemory) + " bytes memory increase when running : ImportCasesSachsen");
        }



if (execStat) {
    runStat.updateStatOnJob(RunStat.JOBEND, fatherNode);
    runStat.stopThreadStat();
}
    int returnCode = 0;
    if(errorCode == null) {
         returnCode = status != null && status.equals("failure") ? 1 : 0;
    } else {
         returnCode = errorCode.intValue();
    }
    resumeUtil.addLog("JOB_ENDED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","" + returnCode,"","","");

    return returnCode;

  }

    // only for OSGi env
    public void destroy() {


    }














    private java.util.Map<String, Object> getSharedConnections4REST() {
        java.util.Map<String, Object> connections = new java.util.HashMap<String, Object>();







        return connections;
    }

    private void evalParam(String arg) {
        if (arg.startsWith("--resuming_logs_dir_path")) {
            resuming_logs_dir_path = arg.substring(25);
        } else if (arg.startsWith("--resuming_checkpoint_path")) {
            resuming_checkpoint_path = arg.substring(27);
        } else if (arg.startsWith("--parent_part_launcher")) {
            parent_part_launcher = arg.substring(23);
        } else if (arg.startsWith("--watch")) {
            watch = true;
        } else if (arg.startsWith("--stat_port=")) {
            String portStatsStr = arg.substring(12);
            if (portStatsStr != null && !portStatsStr.equals("null")) {
                portStats = Integer.parseInt(portStatsStr);
            }
        } else if (arg.startsWith("--trace_port=")) {
            portTraces = Integer.parseInt(arg.substring(13));
        } else if (arg.startsWith("--client_host=")) {
            clientHost = arg.substring(14);
        } else if (arg.startsWith("--context=")) {
            contextStr = arg.substring(10);
            isDefaultContext = false;
        } else if (arg.startsWith("--father_pid=")) {
            fatherPid = arg.substring(13);
        } else if (arg.startsWith("--root_pid=")) {
            rootPid = arg.substring(11);
        } else if (arg.startsWith("--father_node=")) {
            fatherNode = arg.substring(14);
        } else if (arg.startsWith("--pid=")) {
            pid = arg.substring(6);
        } else if (arg.startsWith("--context_type")) {
            String keyValue = arg.substring(15);
			int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.setContextType(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.setContextType(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }

            }

		} else if (arg.startsWith("--context_param")) {
            String keyValue = arg.substring(16);
            int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.put(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.put(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }
            }
        } else if (arg.startsWith("--log4jLevel=")) {
            log4jLevel = arg.substring(13);
		} else if (arg.startsWith("--monitoring") && arg.contains("=")) {//for trunjob call
		    final int equal = arg.indexOf('=');
			final String key = arg.substring("--".length(), equal);
			System.setProperty(key, arg.substring(equal + 1));
		}
    }
    
    private static final String NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY = "<TALEND_NULL>";

    private final String[][] escapeChars = {
        {"\\\\","\\"},{"\\n","\n"},{"\\'","\'"},{"\\r","\r"},
        {"\\f","\f"},{"\\b","\b"},{"\\t","\t"}
        };
    private String replaceEscapeChars (String keyValue) {

		if (keyValue == null || ("").equals(keyValue.trim())) {
			return keyValue;
		}

		StringBuilder result = new StringBuilder();
		int currIndex = 0;
		while (currIndex < keyValue.length()) {
			int index = -1;
			// judege if the left string includes escape chars
			for (String[] strArray : escapeChars) {
				index = keyValue.indexOf(strArray[0],currIndex);
				if (index>=0) {

					result.append(keyValue.substring(currIndex, index + strArray[0].length()).replace(strArray[0], strArray[1]));
					currIndex = index + strArray[0].length();
					break;
				}
			}
			// if the left string doesn't include escape chars, append the left into the result
			if (index < 0) {
				result.append(keyValue.substring(currIndex));
				currIndex = currIndex + keyValue.length();
			}
		}

		return result.toString();
    }

    public Integer getErrorCode() {
        return errorCode;
    }


    public String getStatus() {
        return status;
    }

    ResumeUtil resumeUtil = null;
}
/************************************************************************************************
 *     220864 characters generated by Talend Open Studio for Data Integration 
 *     on the 10 November 2022 at 13:12:03 CET
 ************************************************************************************************/